﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using System.Collections.Generic;

using System.Windows.Controls;
using System.Windows.Media;
using System.Windows;

using System.Globalization; // CultureInfo
using System.Collections;  // ArrayList
using System.Windows.Input; // Cursor

using System.IO;
using System.Windows.Threading;


namespace HtmlWpfRtf.ColorText {
    public class SplitColorTextBox {
        public enum ColorTyp {
            html,
            text,
            space,
            specialchars,
            comments
        }

        public class ColorString {
            public StringBuilder sb = new StringBuilder();
            public ColorTyp colortyp = ColorTyp.text;
        }
        public class StringList {
            public int anzTabs = 0;
            public List<ColorString> colorstrings = new List<ColorString>();
        }

        class LineAbschnitt2 {
            public bool isFertig = false;
            public bool setComment = false;
            public ColorString colorstring = null;
            public String line = "";

            public LineAbschnitt2(String line) {
                this.line = line;
            }
            public LineAbschnitt2(ColorString colorstring) {
                this.colorstring = colorstring;
            }
        }

        // PHP oder Javascript
        private String[] highlightItems = new String[] {
            "$_GET",
            "alert",
            "append",
            "array",
            "as",
            "bin2hex",
            "case",
            "charAt",
            "charCodeAt",
            "class",
            "concat",
            "console",
            "count",
            "display ",
            "do",
            "document",
            "double",
            "Double",
            "echo",
            "element",
            "else",
            "explode",
            "fetch_array",
            "float",
            "for",
            "format",
            "fromCharCode",
            "function",
            "connect_error",
            "foreach",

            "getElementById",
            "getParameterValues",
            "if",
            "import",
            "include",
            "indexOf",
            "innerHTML",
            "int",
            "Integer",
            "intval",
            "is_numeric",
            "is_int",
            "is_float",
            
            "is_bool",
            "is_string",
            "is_array",
            "is_object",

            "isNaN",
            "isset",
            "java",
            "json_encode",
            "lang",
            "lastIndexOf",
            "length",
            "length",
            "let",
            "localeCompare",
            "localhost",
            "log",
            "ltrim",
            "match",
            "mysqli",
            "NaN",
            "new",
            "NumberFormatException",
            "onreadystatechange",
            "open",
            "out",
            "page",
            "parseDouble",
            "parseFloat",
            "parseInt",
            "preg_match",
            "print",
            "println",
            "push",
            "query",
            "readyState",
            "reflect",
            "RegExp",
            "replace",
            "responseText",
            "request",
            "return",
            "root",
            "rtrim",
            "search",
            "send",
            "SimpleDateFormat",
            "slice",
            "split",
            "str_split",
            "strict",
            "String",
            "StringBuilder",
            "strlen",
            "str_replace",
            "strtok",
            "strtoupper",
            "style",
            "substr",
            "substring",
            "this",
            "toExponential",
            "toFixed",
            "toLocaleLowerCase",
            "toLocaleUpperCase",
            "toLowerCase",
            "toPrecision",
            "toString",
            "toUpperCase",
            "trim",
            "trim",
            "use",
            "util",
            "valueOf",
            "var",
            "value",
            "while",
            "window",

            "catch",
            "null",
            "getParameter",
            "boolean",
            "Boolean",
            "double",
            "Double",
            "true",
            "false",
            "intValue",
            "FileInputStream",
            "FileOutputStream",
            "DataInputStream",
            "DataOutputStream",
            "PrintStream",
            "close",
            "IOException",
            "Exception",
            "FileNotFoundException",
            "finally",
            "Connection",
            "Statement",
            "ResultSet",
            "DriverManager",
            "getConnection",
            "createStatement",
            "executeQuery",
            "executeUpdate",
            "try",
            "ArrayList",
            "Class",
            "forName",
            "next",
            "getString",
            "add",

            "XMLHttpRequest"
        };


        private String editText = null;
        private string[] lines = null;

        public List<StringList> gesamtliste = new List<StringList>();

        private double tabsize = 2;



        private ColorTyp checkColorTyp(bool html, char ch) {
            try {
                int code = ch;
                //   é=233   21=§
                if ((code >= 65 && code <= 90) || (code >= 97 && code <= 122) || (code >= 48 && code <= 57) ||
                    (code == 220) || (code == 196) || (code == 214) || (code == 252) || (code == 233) || (code == 228) ||
                    (code == 218) || (code == 217) || (code == 219) || (code == 225) || (code == 224) || (code == 226) ||
                    (code == 250) || (code == 249) || (code == 251) || (code == 232) || (code == 234) ||
                    (code == 201) || (code == 200) || (code == 202) || (code == 193) || (code == 192) || (code == 194) ||
                       (code == 246) || (code == 223) || (code == 21)) {
                    if (html)
                        return ColorTyp.html;  
                    else
                        return ColorTyp.text;
                }
                else if (code == 32) {
                    return ColorTyp.space;
                }
                // 169   copyright     176=°
                else if ((code >= 33 && code <= 47) || (code >= 58 && code <= 64) || (code >= 91 && code <= 96) || (code==176) ||(code >= 123 && code <= 126) || (code==169) || code>255   ) 
                    return ColorTyp.specialchars;
                else {
                    Basis.Message("Fehlerhafte Abfrage in checkColorTyp: char: " + ch+"  code: "+ code, "Info");
                    return ColorTyp.text;
                }
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im checkColorTyp\r\n" + e.ToString(), "Fehler");
                return ColorTyp.text;
            }
        }

        private ColorTyp checkColorTypScript(char ch) {
            try {
                int code = ch;
                if ((code >= 65 && code <= 90) || (code >= 97 && code <= 122) || (code >= 48 && code <= 57) || (code == 95) ||
                    (code == 220) || (code == 196) || (code == 214) || (code == 252) || (code == 228) || (code == 246) || (code == 223)) {
                    return ColorTyp.text;
                }
                else if (code == 32) {
                    return ColorTyp.space;
                }
                else {
                    return ColorTyp.specialchars;
                }
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im checkColorTypScript\r\n" + e.ToString(), "Fehler");
                return ColorTyp.text;
            }
        }
        


        public void splitText(String text) {
            this.editText = text.Replace(Konst.C_TAB, " ");
            string[] splitStrings = { "\r\n" };
            lines = editText.Split(splitStrings, StringSplitOptions.None);

            try {
                gesamtliste.Clear();
                // private List<StringList> liste = new List<StringList>();


                bool html = false;
                bool scriptBlock = false;
                bool scriptComment2 = false;
                StringList stringListLine = null;  // 1x pro Zeile
                ColorString colorstring = null;  // mehrfach pro Zeile
                                                 // <?xml version="1.0" encoding="UTF-8" ?>


                foreach (String line2 in lines) {
                    String line3 = line2.TrimStart();
                    stringListLine = new StringList();
                    if (line2.StartsWith("      "))
                        stringListLine.anzTabs = 6;
                    else if (line2.StartsWith("     "))
                        stringListLine.anzTabs = 5;
                    else if (line2.StartsWith("    "))
                        stringListLine.anzTabs = 4;
                    else if (line2.StartsWith("   "))
                        stringListLine.anzTabs = 3;
                    else if (line2.StartsWith("  "))
                        stringListLine.anzTabs = 2;
                    else if (line2.StartsWith(" "))
                        stringListLine.anzTabs = 1;

                    gesamtliste.Add(stringListLine);
                    colorstring = null;  // noch nichts passiert in der aktuellen Zeile
                    html = false;
                    int posi = 0;
                    ColorString colorstringCommentSlashSlash = null;
                    ColorString colorstringCommentBlock = null;  // 

                    if (scriptBlock) {  // checkColorTypScript
                        List<LineAbschnitt2> lineAbschnittListe = new List<LineAbschnitt2>();

                        lineAbschnittListe.Add(new LineAbschnitt2(line3));
                        while (lineAbschnittListe.Count > 0) {
                            LineAbschnitt2 abschnitt = lineAbschnittListe[0];
                            lineAbschnittListe.RemoveAt(0);
                            if (abschnitt.isFertig) {
                                stringListLine.colorstrings.Add(abschnitt.colorstring);
                                if (abschnitt.setComment) {
                                    //    $w=12;  /*    
                                    scriptComment2 = true;
                                    colorstringCommentBlock = abschnitt.colorstring;  // 1. Teil  /*    ....
                                }
                                continue;
                            }


                            String lineLoop = abschnitt.line;

                            if (scriptComment2) {
                                // suche */
                                posi = lineLoop.IndexOf("*/");
                                if (posi >= 0) {
                                    // ende des Kommentars?         */  $w=12;   /*    ddddd  */
                                    scriptComment2 = false;
                                    // ende Kommentar-Block in die Zeilenabschnittsliste
                                    String linex = lineLoop.Substring(0, posi + 2);  // 2=*/
                                    ColorString colorstring22 = new ColorString();
                                    colorstring22.colortyp = ColorTyp.comments;
                                    colorstring22.sb.Append(linex);
                                    stringListLine.colorstrings.Add(colorstring22);
                                    // den Rest in die While-Liste
                                    linex = lineLoop.Substring(posi + 2);
                                    if (linex.Trim().Length > 0) {
                                        LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                        lineAbschnittListe.Insert(0, abschnitt3);
                                    }
                                    continue;
                                }
                                else {
                                    // komplette Zeile als Kommentar!
                                    if (colorstringCommentBlock == null) {
                                        colorstringCommentBlock = new ColorString();
                                        colorstringCommentBlock.colortyp = ColorTyp.comments;
                                        stringListLine.colorstrings.Add(colorstringCommentBlock);
                                    }
                                    colorstringCommentBlock.sb.Append(lineLoop);
                                    continue;
                                }
                            }
                            else {
                                // if  (!scriptComment2) {
                                posi = lineLoop.IndexOf("//");            //  suche   //  und /*
                                int posi2a = lineLoop.IndexOf("/*");
                                if (posi >= 0 && posi2a >= 0) {
                                    if (posi > posi2a) {
                                        posi = -1;
                                    }
                                    else {
                                        posi2a = -1;
                                    }
                                }

                                if (posi >= 0) {
                                    String str_comment = lineLoop.Substring(posi);
                                    lineLoop = lineLoop.Substring(0, posi);
                                    colorstringCommentSlashSlash = new ColorString();
                                    // teste, welche Gruppe
                                    colorstringCommentSlashSlash.colortyp = ColorTyp.comments;
                                    colorstringCommentSlashSlash.sb.Append(str_comment);
                                }

                                // kein scriptComment2
                                posi = lineLoop.IndexOf("/*");
                                if (posi >= 0) {
                                    // Check, in aktuelle Zeile zu Ende?                              
                                    int posi2 = lineLoop.IndexOf("*/");
                                    if (posi2 >= 0) {
                                        if (posi2 > posi) {
                                            //  a) /*     */      b) int a=1  /*    */    c)  /*  */  a=1     d) a=1; /*   */  b=1;
                                            // umgekehrte Reihenfolge

                                            // text nach den Klammern
                                            String linex = lineLoop.Substring(posi2 + 2);
                                            if (linex.Trim().Length > 0) {
                                                LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                lineAbschnittListe.Insert(0, abschnitt3);
                                            }

                                            // der Klammerbereich
                                            linex = lineLoop.Substring(posi, posi2 - posi + 2);
                                            ColorString colorStringkl = new ColorString();
                                            colorStringkl.colortyp = ColorTyp.comments;
                                            colorStringkl.sb.Append(linex);
                                            LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                            abschnitt5.isFertig = true;
                                            abschnitt5.setComment = false;
                                            lineAbschnittListe.Insert(0, abschnitt5);

                                            // vor dem Klammerbereich
                                            if (posi > 0) {
                                                linex = lineLoop.Substring(0, posi);
                                                if (linex.Length > 0) {
                                                    LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                    lineAbschnittListe.Insert(0, abschnitt3);
                                                }
                                            }
                                            continue;
                                        }
                                        else {
                                            // Fall: max zwei Abschnitte!   int a=1;  /*       int a=1; in die Liste am Anfang
                                            // Klammerbereich, aktivieren des SetComments
                                            String linex = lineLoop.Substring(posi);
                                            ColorString colorStringkl = new ColorString();
                                            colorStringkl.colortyp = ColorTyp.comments;
                                            colorStringkl.sb.Append(linex);
                                            LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                            abschnitt5.isFertig = true;
                                            abschnitt5.setComment = true;
                                            lineAbschnittListe.Insert(0, abschnitt5);

                                            linex = lineLoop.Substring(0, posi - 1);
                                            if (linex.Length > 0) {
                                                LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                lineAbschnittListe.Insert(0, abschnitt3);
                                            }
                                            continue;
                                        }
                                    }
                                    else {
                                        //  /*  fängt an

                                        // Fall: zwei Abschnitte!   int a=1;  /*     int a=1; in die Liste am Anfang
                                        String linex = lineLoop.Substring(posi);
                                        ColorString colorStringkl = new ColorString();
                                        colorStringkl.colortyp = ColorTyp.comments;
                                        colorStringkl.sb.Append(linex);
                                        LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                        abschnitt5.isFertig = true;
                                        abschnitt5.setComment = true;  // !!!!
                                        lineAbschnittListe.Insert(0, abschnitt5);

                                        if (posi > 0) {
                                            linex = lineLoop.Substring(0, posi - 1);
                                            if (linex.Length > 0) {
                                                LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                lineAbschnittListe.Insert(0, abschnitt3);
                                            }
                                        }
                                        continue;  // 
                                    }
                                }
                            }

                            foreach (char ch in lineLoop) {
                                if (colorstring == null) {
                                    colorstring = new ColorString();
                                    stringListLine.colorstrings.Add(colorstring);
                                    // teste, welche Gruppe
                                    colorstring.colortyp = checkColorTypScript(ch);
                                    colorstring.sb.Append(ch);
                                }
                                else {
                                    ColorTyp colortyp = checkColorTypScript(ch);
                                    // test, ob die Gruppe identisch ist
                                    if (colorstring.colortyp == colortyp) {
                                        colorstring.sb.Append(ch);
                                    }
                                    else {
                                        colorstring = new ColorString();
                                        stringListLine.colorstrings.Add(colorstring);
                                        // neue Gruppe
                                        colorstring.colortyp = colortyp;
                                        colorstring.sb.Append(ch);
                                    }
                                }

                            }  // foreach (char ch in line) {
                               // nun loop über alle AbschnittsTexte und check mit den Items der highlight-Liste
                        }  // while lineAbschnittListe.Count>0

                        if (colorstringCommentSlashSlash != null) {
                            stringListLine.colorstrings.Add(colorstringCommentSlashSlash);
                        }
                        foreach (ColorString colorstring2 in stringListLine.colorstrings) {
                            if (colorstring2.colortyp != ColorTyp.comments) {
                                foreach (String item in highlightItems) {
                                    if (colorstring2.sb.ToString().Equals(item)) {
                                        colorstring2.colortyp = ColorTyp.html;
                                        break;
                                    }
                                }
                            }
                        }

                        // 
                    }
                    else {
                        foreach (char ch in line3) {
                            if (ch == '<') {  // 60<   62>
                                html = true;
                            }
                            else if (ch == '>') {  // 60<   62>
                                html = false;
                            }

                            if (colorstring == null) {
                                colorstring = new ColorString();
                                stringListLine.colorstrings.Add(colorstring);
                                // teste, welche Gruppe
                                colorstring.colortyp = checkColorTyp(html, ch);
                                colorstring.sb.Append(ch);
                            }
                            else {
                                ColorTyp colortyp = checkColorTyp(html, ch);
                                // test, ob die Gruppe identisch ist
                                if (colorstring.colortyp == colortyp) {
                                    colorstring.sb.Append(ch);
                                }
                                else {
                                    colorstring = new ColorString();
                                    stringListLine.colorstrings.Add(colorstring);
                                    // neue Gruppe
                                    colorstring.colortyp = colortyp;
                                    colorstring.sb.Append(ch);
                                }
                            }

                        }  // foreach (char ch in line) {
                    }
                    // <script type="text/javascript">  <?php  <%     </script   ?>  %>
                    if (line3.IndexOf("<script") >= 0 || line3.IndexOf("<?php") >= 0 || line3.IndexOf("<%") >= 0) {
                        scriptBlock = true;  // checkColorTypScript
                    }
                    if (line3.IndexOf("</script") >= 0 || line3.IndexOf("?>") >= 0 || line3.IndexOf("%>") >= 0) {
                        scriptBlock = false;  // checkColorTypScript
                    }


                }  // foreach (String line in lines) {
            }
            catch (Exception e) {
                Basis.ErrorMsg("Exception im splitText\r\n" + e.ToString(), "Fehler");
            }
        }

    }
}
