﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace HtmlWpfRtf.Common {
    /// <summary>
    /// Interaktionslogik für FNewFile.xaml
    /// </summary>
    public partial class WNewFile : Window {

        public const int C_HTMLCSS = 1;
        public const int C_HTML = 2;
        public const int C_CSS = 3;
        public const int C_PHP = 4;
        public const int C_PHPPUR = 5;
        public const int C_HTML5 = 6;
        public const int C_JSPHTML = 7;
        public const int C_JSPPUR1 = 8;
        public const int C_JAVASCRIPT = 9;
        

        private int retcode = -1;  // Abbruch
        private int layout = 0;

        public int RetCode {
            get { return retcode; }
        }
        public int Layout {
            get { return layout; }
        }

        public WNewFile(Window owner) {
            InitializeComponent();
            this.Owner = owner;
            this.WindowStartupLocation = System.Windows.WindowStartupLocation.CenterOwner;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            rbHTMLCSS.IsChecked = true;
            rbHTMLCSS.Focus();
        }

        private void rbNolayout_Click(Object sender, RoutedEventArgs e) {
            imgFlex1.Visibility = Visibility.Collapsed;
            imgFlex2.Visibility = Visibility.Collapsed;
            imgFlex3.Visibility = Visibility.Collapsed;
            layout = 0;
        }

        private void rbGridlayout1_Click(Object sender, RoutedEventArgs e) {
            imgFlex1.Visibility = Visibility.Visible;
            imgFlex2.Visibility = Visibility.Collapsed;
            imgFlex3.Visibility = Visibility.Collapsed;
            layout = 1;

        }

        private void rbGridlayout2_Click(Object sender, RoutedEventArgs e) {
            imgFlex1.Visibility = Visibility.Collapsed;
            imgFlex2.Visibility = Visibility.Visible;
            imgFlex3.Visibility = Visibility.Collapsed;
            layout = 2;
        }

        private void rbGridlayout3_Click(Object sender, RoutedEventArgs e) {
            imgFlex1.Visibility = Visibility.Collapsed;
            imgFlex2.Visibility = Visibility.Collapsed;
            imgFlex3.Visibility = Visibility.Visible;
            layout = 3;
        }

        private void rbFlexlayout1_Click(object sender, RoutedEventArgs e)  {
            imgFlex1.Visibility = Visibility.Visible;
            imgFlex2.Visibility = Visibility.Collapsed;
            imgFlex3.Visibility = Visibility.Collapsed;
            layout = 4;
        }

        private void rbFlexlayout2_Click(object sender, RoutedEventArgs e)  {
            imgFlex1.Visibility = Visibility.Collapsed;
            imgFlex2.Visibility = Visibility.Visible;
            imgFlex3.Visibility = Visibility.Collapsed;
            layout = 5;
        }

        private void rbFlexlayout3_Click(object sender, RoutedEventArgs e)  {
            imgFlex1.Visibility = Visibility.Collapsed;
            imgFlex2.Visibility = Visibility.Collapsed;
            imgFlex3.Visibility = Visibility.Visible;
            layout = 6;
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            if (rbHTMLCSS.IsChecked == true) retcode = C_HTMLCSS;
            if (rbXHTML5.IsChecked == true) retcode = C_HTML5;
            if (rbHTML.IsChecked == true) retcode = C_HTML;
            if (rbCSS.IsChecked == true) retcode = C_CSS;
            if (rbPHP.IsChecked == true) retcode = C_PHP;
            if (rbPHPPur.IsChecked == true) retcode = C_PHPPUR;
            if (rbJSPhtml.IsChecked == true) retcode = C_JSPHTML;
            if (rbJSPPur.IsChecked == true) retcode = C_JSPPUR1;
            if (rbJs.IsChecked == true) retcode = C_JAVASCRIPT;
            
            Close();
        }


        private void bnEsc_Click(object sender, RoutedEventArgs e) {
            Close();
        }


        private void Window_KeyDown(object sender, KeyEventArgs e) {
            if (Keyboard.IsKeyDown(Key.Return)) {
                e.Handled = true;
                bnOk_Click(sender, e);
            }
        }

        private void rb_Click(object sender, RoutedEventArgs e) {
            if (rbHTMLCSS.IsChecked == true || rbXHTML5.IsChecked == true || rbHTML.IsChecked == true
                || rbPHP.IsChecked == true || rbPHPPur.IsChecked == true || rbJSPhtml.IsChecked == true) {
                groupbox2.IsEnabled = true;
            }
            else {
                if (rbCSS.IsChecked == true || rbJSPPur.IsChecked == true || rbJs.IsChecked == true) {
                    groupbox2.IsEnabled = false;
                }
                else {
                    Basis.ErrorMsg("Falsche If-Bedingung, Modul FNewFile, Methode rb_Click", "Interner Fehler");
                    groupbox2.IsEnabled = true;
                }
            }
        }

    }
}
