﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

using System.Diagnostics;  // run

namespace HtmlWpfRtf.Common { 
    /// <summary>
    /// Interaktionslogik für FProgInfo.xaml
    /// </summary>
    public partial class WProgInfo : Window {
        public WProgInfo(Window parent) {
            InitializeComponent();
            this.Owner = parent;  // Important, because CenterOwner            
        }

        private void Window_Loaded(object sender, RoutedEventArgs e) {
            LVersion.Content = "Version 2,6 Build 1240, 30.06.2023"; 
            // this.WindowStartupLocation = WindowStartupLocation.CenterOwner;  // nur in XAML
            createOSInfo();      
        }       

        private void createOSInfo()    {
            var version = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version;
            int major = version.Major;   
            int minor = version.Minor;  
            int build = version.Build;    
            int revision = version.Revision;      

            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Computername: " + System.Environment.MachineName);
            sb.AppendLine("BS-Version: " + System.Environment.OSVersion);
            sb.AppendLine("Version: " + System.Environment.Version);
            if (System.Environment.Is64BitOperatingSystem)
                sb.AppendLine("  64-Bit-Version");
            else 
                sb.AppendLine("  32-Bit-Version");
            sb.AppendLine("Benutzername: " + System.Environment.UserName);
            sb.AppendLine("Anzahl der CPU's: " + System.Environment.ProcessorCount);
            this.textBoxDescription1.Text = sb.ToString();
            textBoxDescription1.SelectionStart = 0;
        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }


        private void Label_MouseDown(object sender, MouseButtonEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "http://mwilhelm.hs-harz.de";
            Prog.StartInfo.Arguments = "";
            Prog.Start();  
        }

        private void Label_MouseDown_1(object sender, MouseButtonEventArgs e) {
            Process Prog = new Process();
            Prog.StartInfo.FileName = "mailto:mwilhelm@hs-harz.de";
            Prog.StartInfo.Arguments = "";
            Prog.Start();
        }
    }
}
