﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HtmlWpfRtf {
    class FileObject : IComparable {

        public String name;
        public Boolean isDir;
        public Boolean isParent;

        public FileObject(String name, Boolean isDir, Boolean isParent)
        {
            this.name = name;
            this.isDir = isDir;
            this.isParent = isParent;
        }

        public override String ToString()
        {
            if (isDir)
                return " - " + name;
            else
                return name;
        }

        public int CompareTo(object obj)  {
            
            FileObject fo2 = (FileObject)obj;
            int retcode = 0;
            if (isDir && !fo2.isDir) {
                // I'm am a directory, the param not
                return -1;
            }
            else {
                if (!isDir && fo2.isDir) {
                    // I'm am not a directory, the param is a directoy
                    return +1;
                }
                else {
                    // I'm am a directory, the param is also a directoy
                    if (isDir && fo2.isDir) {
                        if (isParent) return -1;  // ".."
                        if (fo2.isParent) return +1;
                        retcode = name.CompareTo(fo2.name);
                    }
                    else {
                        retcode = name.CompareTo(fo2.name);
                    }
                }
            }
            return retcode;
        }

    }
}

