﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace HtmlWpfRtf {
    public class IntellisenseManagement {

        public static List<Intellisense> dataHTML = new List<Intellisense>();
        public static List<Intellisense> dataJavaScript = new List<Intellisense>();
        public static List<Intellisense> dataPHPScript = new List<Intellisense>();
        public static List<Intellisense> dataJSPScript = new List<Intellisense>();

        static IntellisenseManagement() {
            setDataHTML();
            setJavaScript(ref dataHTML);
            setPHPScript(ref dataHTML);
            setJSPScript(ref dataHTML);

            setJavaScript(ref dataJavaScript);
            setPHPScript(ref dataPHPScript);
            setJSPScript(ref dataJSPScript);
        }



        private static void setJavaScript(ref List<Intellisense> data) {
            data.Add(new Intellisense("","","<script type=\"text/javascript\">\r\n" +
                    "      // <![CDATA[\r\n" +
                    "      \"use strict\";\r\n" +
                    "      function  f(form) {\r\n" +
                    "        \"use strict\";\r\n" +
                    "        alert(\"here in f\") ;\r\n" +
                    "      }\r\n" +
                    "      // ]]>\r\n" +
                    "</script>\r\n",0));
            data.Add(new Intellisense("parseInt", "", Konst.C_TAB+"parseInt(str_n)",0));
            data.Add(new Intellisense("parseFloat", "", Konst.C_TAB + "parseFloat(str_n)",0));
            data.Add(new Intellisense("getElementById", Konst.C_TAB + "let element = document.getElementById", "let element = document.getElementById(\"id\",0));",0));
            data.Add(new Intellisense("document", "document.getElementById", Konst.C_TAB + "document.getElementById(\"id\",0));",0));


            data.Add(new Intellisense("innerHTML", "",".innerHTML = '<h2>Hier ist eine Überschrift</h2>';",0));

            data.Add(new Intellisense("const", "const Konstante", Konst.C_TAB + "const Konstante = 1;", 0));

            data.Add(new Intellisense("for", "for (let i=; i< ; i++ )", Konst.C_TAB + "for (let i=; i< ; i++ ) {\r\n\r\n}", 0));

            data.Add(new Intellisense("for", "for (let i in objs)", Konst.C_TAB + "for (let i in objs) {\r\n\r\n}", 0));
            data.Add(new Intellisense("for", "for (let item of objs)", Konst.C_TAB + "for (let item of objs) {\r\n\r\n}", 0));


            data.Add(new Intellisense("if","", Konst.C_TAB + "if(bed) {\r\n}", 3));
            data.Add(new Intellisense("if", "if () else", Konst.C_TAB + "if(bed) {\r\n}\r\nelse{\r\n}", 3));
            data.Add(new Intellisense("if", "if ($ok) else", Konst.C_TAB + "if($ok) {\r\n"+ Konst.C_TAB+"}\r\nelse{\r\n"+ Konst.C_TAB+"}", 3));
            data.Add(new Intellisense("if", "if ($ok) else Error", Konst.C_TAB + "if($ok) {\r\n" + Konst.C_TAB + "}\r\nelse{\r\n" + 
                     Konst.C_TAB + Konst.C_TAB + "echo '<h2>Fehler</h2>';\r\n"+ Konst.C_TAB + Konst.C_TAB+"echo $errortext;\r\n"
                     + Konst.C_TAB + "}", 3));

            data.Add(new Intellisense("if", "if ($ok) Result else Result Error", 
                     Konst.C_TAB + "if ($ok) {\r\n" +
                     Konst.C_TAB + Konst.C_TAB+ "$result = new Result();\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "echo json_encode($result);\r\n" +
                     Konst.C_TAB + "} else {\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "$result = new Result();\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "$result->isError=true';\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "$result->errortext =$errortext';\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "echo json_encode($result);\r\n" +
                     Konst.C_TAB + "}", 3));
             


            data.Add(new Intellisense("while", "while (bed)", Konst.C_TAB + "while (bed){\r\n}", 7));
            data.Add(new Intellisense("switch (Bed) {..}","", Konst.C_TAB + "switch (Bed) {\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "  case 0:\r\n" +
                     Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "    break;\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "  case 1:\r\n" +
                     Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "   break;\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "  default:\r\n" +
                     Konst.C_TAB + Konst.C_TAB + "   break;\r\n" +  
                     Konst.C_TAB + "}",8));
            data.Add(new Intellisense("charAt", "",  ".charAt(0)", 0));
            data.Add(new Intellisense("charCodeAt", "",".charCodeAt()",0));
            data.Add(new Intellisense("concat", "",".concat(\"abc\",0));",0));
            data.Add(new Intellisense("length", "",".length",0));
            data.Add(new Intellisense("fromCharCode", "",".fromCharCode(65);",0));
            data.Add(new Intellisense("indexOf", "",".indexOf(\"abc\",0));",0));
            data.Add(new Intellisense("lastIndexOf", "",".lastIndexOf(\"\\);",0));
            data.Add(new Intellisense("localeCompare", "",".localeCompare(\"abc\",0));",0));
            data.Add(new Intellisense("replace", "",".replace(\"abc\", \"xyz\",0));",0));
            data.Add(new Intellisense("search", "",".search((\"abc\",0));  // return the position of abc, -1=not found, regular expression, slower ",0));
            data.Add(new Intellisense("slice", "",".slice(1,5);",0));
            data.Add(new Intellisense("split", "",".split(',');",0));
            data.Add(new Intellisense("substr", "",".substr(1,5);  // start<= chars <= end; (0->n-1)",0));
            data.Add(new Intellisense("substring", "",".substring(1,5);  // start<= chars < end; (0->n-1)",0));
            data.Add(new Intellisense("toLocaleLowerCase", "",".toLocaleLowerCase();",0));
            data.Add(new Intellisense("toLocaleUpperCase", "",".toLocaleUpperCase();",0));
            data.Add(new Intellisense("toLowerCase", "",".toLowerCase();",0));
            data.Add(new Intellisense("toUpperCase", "",".toUpperCase();",0));
            data.Add(new Intellisense("trim", "",".trim();",0));
            data.Add(new Intellisense("toExponential", "",".toExponential();",0));
            data.Add(new Intellisense("array","","new array(MAX)",0));
            data.Add(new Intellisense("toPrecision", "",".toPrecision(4);",0));

            data.Add(new Intellisense(".charAt", "charAt", ".charAt(0)", 0));
            data.Add(new Intellisense(".charCodeAt", "charCodeAt", ".charCodeAt()", 0));
            data.Add(new Intellisense(".concat", "concat", ".concat(\"abc\",0));", 0));
            data.Add(new Intellisense(".length", "length", ".length", 0));
            data.Add(new Intellisense(".fromCharCode", "fromCharCode", ".fromCharCode(65);", 0));
            data.Add(new Intellisense(".indexOf", "indexOf", ".indexOf(\"abc\",0));", 0));
            data.Add(new Intellisense(".lastIndexOf", "lastIndexOf", ".lastIndexOf(\"\\);", 0));
            data.Add(new Intellisense(".localeCompare", "localeCompare", ".localeCompare(\"abc\",0));", 0));
            data.Add(new Intellisense(".replace", "replace", ".replace(\"abc\", \"xyz\",0));", 0));
            data.Add(new Intellisense(".search", "search", ".search((\"abc\",0));  // return the position of abc, -1=not found, regular expression, slower ", 0));
            data.Add(new Intellisense(".slice", "slice", ".slice(1,5);", 0));
            data.Add(new Intellisense(".split", "split", ".split(',');", 0));
            data.Add(new Intellisense(".substr", "substr", ".substr(1,5);  // start<= chars <= end; (0->n-1)", 0));
            data.Add(new Intellisense(".substring", "substring", ".substring(1,5);  // start<= chars < end; (0->n-1)", 0));
            data.Add(new Intellisense(".toLocaleLowerCase", "toLocaleLowerCase", ".toLocaleLowerCase();", 0));
            data.Add(new Intellisense(".toLocaleUpperCase", "toLocaleUpperCase", ".toLocaleUpperCase();", 0));
            data.Add(new Intellisense(".toLowerCase", "toLowerCase", ".toLowerCase();", 0));
            data.Add(new Intellisense(".toUpperCase", "toUpperCase", ".toUpperCase();", 0));
            data.Add(new Intellisense(".trim", "trim", ".trim();", 0));
            data.Add(new Intellisense(".toExponential", "toExponential", ".toExponential();", 0));
            data.Add(new Intellisense(".array", "array", "new array(MAX)", 0));
            data.Add(new Intellisense(".toPrecision", "toPrecision", ".toPrecision(4);", 0));

        }  // setJavaScript


        private static void setDataHTML() {
            dataHTML.Add(new Intellisense("html", "<html>", "<html>",0));
            dataHTML.Add(new Intellisense("html", "</html>", "</html>",0));
            dataHTML.Add(new Intellisense("body", "<body>", "<body>",0));
            dataHTML.Add(new Intellisense("body", "</body>", "</body>",0));

            
            dataHTML.Add(new Intellisense("br", " '<br />';", " '<br />';", 0));
            dataHTML.Add(new Intellisense("br", "<br />", " '<br />';", 0));


            dataHTML.Add(new Intellisense("table", "<table>...", Konst.C_TAB + "<table>\r\n<tr><th></th><th></th></tr>\r\n<tr><td></td><td></td></tr>\r\n</table>", 0));
            dataHTML.Add(new Intellisense("table", "<table>...</table>", Konst.C_TAB + "<table>\r\n<tr><th></th><th></th></tr>\r\n<tr><td></td><td></td></tr>\r\n</table>", 0));
            dataHTML.Add(new Intellisense("table", "<table>", Konst.C_TAB + "<table>", 0));
            dataHTML.Add(new Intellisense("table", "</table>", Konst.C_TAB + "</table>", 0));
            dataHTML.Add(new Intellisense("/table", "</table>", Konst.C_TAB + "</table>", 0));
            dataHTML.Add(new Intellisense("tr", "<tr>", Konst.C_TAB + "<tr>", 0));
            dataHTML.Add(new Intellisense("tr", "</tr>", Konst.C_TAB + "</tr>",0));
            dataHTML.Add(new Intellisense("th", "<th>", Konst.C_TAB + "<th>", 0));
            dataHTML.Add(new Intellisense("th", "</th>", Konst.C_TAB + "</th>", 0));
            dataHTML.Add(new Intellisense("td", "<td>", Konst.C_TAB + "<td>", 0));
            dataHTML.Add(new Intellisense("td", "</td>", Konst.C_TAB + "</td>", 0));
            dataHTML.Add(new Intellisense("ajax", "<div id=\"ajax\"></div>", Konst.C_TAB + "<div id=\"ajax\"></div>", 0));
            dataHTML.Add(new Intellisense("div", "<div>", Konst.C_TAB + "<div>", 0));
            dataHTML.Add(new Intellisense("div", "</div>", Konst.C_TAB + "</div>",0));
            dataHTML.Add(new Intellisense("h1", "<h1>", Konst.C_TAB + "<h1>",0));
            dataHTML.Add(new Intellisense("h1", "</h1>", Konst.C_TAB + "</h1>", 0));
            dataHTML.Add(new Intellisense("h2", "<h2>", Konst.C_TAB + "<h2>", 0));
            dataHTML.Add(new Intellisense("h2", "</h2>", Konst.C_TAB + "</h2>", 0));
            dataHTML.Add(new Intellisense("h3", "<h3>", Konst.C_TAB + "<h3>", 0));
            dataHTML.Add(new Intellisense("h3", "</h3>", Konst.C_TAB + "</h3>", 0));
            dataHTML.Add(new Intellisense("h4", "<h4>", Konst.C_TAB + "<h4>", 0));
            dataHTML.Add(new Intellisense("h4", "</h4>", Konst.C_TAB + "</h4>", 0));
            dataHTML.Add(new Intellisense("h5", "<h5>", Konst.C_TAB + "<h5>", 0));
            dataHTML.Add(new Intellisense("h5", "</h5", Konst.C_TAB + "</h5", 0));

            dataHTML.Add(new Intellisense("ul", "<ul>", Konst.C_TAB + "<ul>", 0));
            dataHTML.Add(new Intellisense("ul", "</ul>", Konst.C_TAB + "</ul>", 0));
            dataHTML.Add(new Intellisense("ol", "<ol>", Konst.C_TAB + "<ol>",0));
            dataHTML.Add(new Intellisense("ol", "</ol>", Konst.C_TAB + "</ol>", 0));
            dataHTML.Add(new Intellisense("li", "<li>", Konst.C_TAB + Konst.C_TAB + "<li>", 0));
            dataHTML.Add(new Intellisense("li","</li>", Konst.C_TAB + Konst.C_TAB + "</li>", 0));

            dataHTML.Add(new Intellisense("form", "<form>", Konst.C_TAB + "<form>", 0));
            //dataHTML.Add(new Intellisense("for", "<form>", "<form>", 0));

            dataHTML.Add(new Intellisense("form", "<form method=\"get\" ...", Konst.C_TAB + "<form method=\"get\" action=\"test.php\" >", 0));
            //dataHTML.Add(new Intellisense("for", "<form method=\"get\" ...", "<form method=\"get\" action=\"test.php\" >", 0));

            dataHTML.Add(new Intellisense("form", "</form>", Konst.C_TAB + "</form>", 0));
            //dataHTML.Add(new Intellisense("for", "</form>", "</form>", 0));
            dataHTML.Add(new Intellisense("/form", "", Konst.C_TAB + "</form>", 0));



            dataHTML.Add(new Intellisense("fieldset", "<fieldset><legend>", Konst.C_TAB + "<fieldset><legend>Überschrift</legend>",0));
            dataHTML.Add(new Intellisense("fieldset", "</fieldset>", Konst.C_TAB + "</fieldset>", 0));

            dataHTML.Add(new Intellisense("input", "input hidden", Konst.C_TAB + "<input type=\"hidden\" name=\"geheim\" value=\"passwort\" size =\"12\" />", 0));
            dataHTML.Add(new Intellisense("input", "input text", Konst.C_TAB + "<input type=\"text\" name=\"input\" value =\"12\" size =\"12\" />", 0));
            dataHTML.Add(new Intellisense("input", "input number", Konst.C_TAB + "<input type=\"number\" name=\"zahl1\"  min=\"0\"  max=\"100\" value =\"12\" />\r\n<br />", 0));
            dataHTML.Add(new Intellisense("input", "input submit", Konst.C_TAB + "<input type=\"submit\" value=\"Send\" />", 0));
            dataHTML.Add(new Intellisense("input", "input button", Konst.C_TAB + "<input type=\"button\" value=\"Send\" onclick=\"calc(this.form)\" />", 0));
            dataHTML.Add(new Intellisense("input", "input reset", Konst.C_TAB + "<input type=\"reset\" value=\"Delete\" />\r\n<br />)", 0));
            dataHTML.Add(new Intellisense("input", "input submit, formaction", Konst.C_TAB + "<input type=\"submit\" value=\"Send\" formaction=\"page1.xhtml\" formmethod=\"get\" />", 0));
            dataHTML.Add(new Intellisense("input", "input text pattern", Konst.C_TAB + "<input type=\"text\" name=\"lastname\"\r\nplaceholder=\"Vorgabetext(placeholder)\"\r\npattern=\"[A-ZÜÄÖ]{1}[a-züäöß]{1,29}\" value=\"Vorgabetext\" size=\"12\"\r\nautofocus=\"autofocus\" required=\"required\" />", 0));
            dataHTML.Add(new Intellisense("pattern", "input text pattern", Konst.C_TAB + "<input type=\"text\" name=\"lastname\"\r\nplaceholder=\"Vorgabetext(placeholder)\"\r\npattern=\"[A-ZÜÄÖ]{1}[a-züäöß]{1,29}\" value=\"Vorgabetext\" size=\"12\"\r\nautofocus=\"autofocus\" required=\"required\" />", 0));

            dataHTML.Add(new Intellisense("hidden", "input hidden", Konst.C_TAB + "<input type=\"hidden\" name=\"geheim\" value=\"passwort\" size =\"12\" />", 0));
            dataHTML.Add(new Intellisense("text", "input text", Konst.C_TAB + "<input type=\"text\" name=\"input\" value =\"12\" size =\"12\" />", 0));
            dataHTML.Add(new Intellisense("number", "input number", Konst.C_TAB + "<input type=\"number\" name=\"zahl1\"  min=\"0\"  max=\"100\" value =\"12\" />\r\n<br />", 0));
            dataHTML.Add(new Intellisense("submit", "input submit", Konst.C_TAB + "<input type=\"submit\" value=\"Send\" />", 0));
            dataHTML.Add(new Intellisense("button", "input button", Konst.C_TAB + "<input type=\"button\" value=\"Send\" onclick=\"calc(this.form)\" />", 0));
            dataHTML.Add(new Intellisense("reset", "input reset", Konst.C_TAB + "<input type=\"reset\" value=\"Delete\" />\r\n<br />)", 0));
            dataHTML.Add(new Intellisense("submit", "input submit, formaction", Konst.C_TAB + "<input type=\"submit\" value=\"Send\" formaction=\"page1.xhtml\" formmethod=\"get\" />", 0));

            dataHTML.Add(new Intellisense("pattern", "", Konst.C_TAB + "<input type=\"text\" name=\"zahl\"\r\nplaceholder=\"Vorgabetext(placeholder)\"\r\npattern=\"[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}\" value=\"Vorgabetext\" size=\"12\"\r\nautofocus=\"autofocus\" required=\"required\" />", 0));
            dataHTML.Add(new Intellisense("<pattern", "", Konst.C_TAB + "<input type=\"text\" name=\"zahl\"\r\nplaceholder=\"Vorgabetext(placeholder)\"\r\npattern=\"[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}\" value=\"Vorgabetext\" size=\"12\"\r\nautofocus=\"autofocus\" required=\"required\" />", 0));

            dataHTML.Add(new Intellisense("checkbox", "", Konst.C_TAB + "<input type=\"checkbox\" name=\"cad1\" value=\"CAD1\" /> AutoCAD\r\n<br />", 0));
            dataHTML.Add(new Intellisense("radio", "", Konst.C_TAB + "<input type=\"radio\" name = \"R1\" value=\"CAD1\" checked=\"checked\" /> AutoCAD\r\n<br />", 0));
            dataHTML.Add(new Intellisense("select", "select combobox", Konst.C_TAB + "<select name=\"objekte\" >\r\n  <option>Circle</option>\r\n" +
                Konst.C_TAB + "<option selected=\"selected\"> Square </ option >\r\n" +
                Konst.C_TAB + "</select>", 0));
            dataHTML.Add(new Intellisense("combox", "select combobox", Konst.C_TAB + "<select name=\"objekte\" >\r\n  <option>Circle</option>\r\n" +
                Konst.C_TAB + "<option selected=\"selected\"> Square </ option >\r\n" +
                Konst.C_TAB + "</select>", 0));

            dataHTML.Add(new Intellisense("label", "", Konst.C_TAB + "<label for=\"userId\">\r\n1. Zahl\r\n</label>", 0));
            dataHTML.Add(new Intellisense("<label", "", Konst.C_TAB + "<label for=\"userId\">\r\n1. Zahl\r\n</label>", 0));



            dataHTML.Add(new Intellisense("stylesheet", "<link rel=\"stylesheet\" ...", Konst.C_TAB + "<link rel=\"stylesheet\" type=\"text/ css\" href=\"testmi.css\" title=\"style1\"/>", 0));
        }

        private static void setPHPScript(ref List<Intellisense> data) {
            data.Add(new Intellisense("intval", "","intval ( $str_zahl );",0));
            data.Add(new Intellisense("array","","array();",0));
            data.Add(new Intellisense("array","append an element","[] = 'newItem';",0));
            data.Add(new Intellisense("echo","","echo ' < p > Hier kommt ein Text in der HTML - Datei </ p > ' . PHP_EOL;",0));
            data.Add(new Intellisense("count","count(array)","count($feld)",0));
            data.Add(new Intellisense("char","","char",0));
            data.Add(new Intellisense("for", "for ($i=0; $i<$n; $i++) ", Konst.C_TAB + "for ($i=0; $i<$n; $i++) {\r\n}", 5));
            data.Add(new Intellisense("for", "foreach ($liste as $item)", Konst.C_TAB + "foreach ($liste as $item) {\r\n}", 5));
            data.Add(new Intellisense("foreach", "foreach ($liste as $item)", Konst.C_TAB + "foreach ($liste as $item) {\r\n}", 5));
            data.Add(new Intellisense("explode", "","explode('->', $staedte );",0));
            data.Add(new Intellisense("ltrim","","ltrim(",0));
            data.Add(new Intellisense("rtim","","rtrim(",0));
            data.Add(new Intellisense("trim","","trim(",0));
            data.Add(new Intellisense("strlen","","strlen(",0));
            data.Add(new Intellisense("bin2hex", "","bin2hex(",0));
            data.Add(new Intellisense("str_split", "","str_split(",0));
            data.Add(new Intellisense("strtok", "","strtok(",0));
            data.Add(new Intellisense("substr", "","substr(",0));
            data.Add(new Intellisense("lower", "strtolower", "strtolower(",0));
            data.Add(new Intellisense("upper", "strtoupper", "strtoupper(",0));
            data.Add(new Intellisense("strtolower", "", "strtolower(", 0));
            data.Add(new Intellisense("strtoupper", "", "strtoupper(", 0));
        }
        private static void setJSPScript(ref List<Intellisense> data) {
            data.Add(new Intellisense("request", "request.getParameter", Konst.C_TAB + "request.getParameter(\"key\",0));",0));
            data.Add(new Intellisense("request", "request.getParameterValues", Konst.C_TAB + "request.getParameterValues(\"themen\",0));",0));
            data.Add(new Intellisense("for", "for (int i=0; i<n; i++)", Konst.C_TAB + "for (int i=0; i<n; i++) {\r\n}",5));
            data.Add(new Intellisense("out", "out.println()", Konst.C_TAB + "out.println();", 12));
            data.Add(new Intellisense("syso", "out.println()", Konst.C_TAB + "out.println();", 12));
            data.Add(new Intellisense("util", "<%@ page import = \"java.util.* \" %>", Konst.C_TAB + "<%@ page import = \"java.util.* \" %>",0));
            data.Add(new Intellisense("io", "<%@ page import = \"java.io.* \" %>", Konst.C_TAB + "<%@ page import = \"java.io.* \" %>",0));
            data.Add(new Intellisense("=", "<%= value %>", Konst.C_TAB + "<%= value %>",0));
            data.Add(new Intellisense("//", "<%-- jsp comment --%>", Konst.C_TAB + "<%-- jsp comment --%>",0));
            //data.Add(new Intellisense("","","while (...) {\r\n}",0));  
        }


    }
}
