﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Collections;
using System.IO;
using System.Windows;


namespace HtmlWpfRtf {
    public class OldFiles {
        public static string C_OLDFILE_MARKER = "!§$%&/()=?";
        // instance muss nach C_REG_ADR kommen
        private static OldFiles instance = new OldFiles();

        public ArrayList oldfiles = new ArrayList();


        private OldFiles() {
            loadOldFiles();  // aus Registry Adresse
        }

        public static OldFiles getInstance() {
            return instance;
        }

        public void clearOldFiles() {
            oldfiles.Clear();
        }

        public int count_oldfiles {
            get { return oldfiles.Count; }
        }

        public string getOldfile(int i) {
            if (i >= 0 && i < oldfiles.Count)
                return (string)oldfiles[i];
            else
                return null;
        }

        public void saveOldFile(String sFilename) {
            oldfiles.Add(sFilename);
        }

        public void loadOldFiles() {
            oldfiles.Clear();
            int n = Basis.ReadRegInt(SingVar.C_REG_ADR + "\\Files", "COUNT_FILES");
            if (n >= 10) n = 15;
            for (int i = 0; i < n; i++) {
                string sFile = Basis.ReadRegString(SingVar.C_REG_ADR + "\\Files", "FILE_" + (i + 1).ToString());
                if (File.Exists(sFile)) {
                    oldfiles.Add(sFile);
                }

            }
        }

        public void saveFileToOldFiles(string sFilename) {
            foreach (string file in oldfiles) {
                if (file.Equals(sFilename, StringComparison.InvariantCultureIgnoreCase)) {
                    return;  // schon vorhanden
                }
            }
            oldfiles.Insert(0, sFilename);
        }  // saveFile

        public void deleteFileFromOldFiles(string sFilename) {
            foreach (string file in oldfiles) {
                if (file.Equals(sFilename, StringComparison.InvariantCultureIgnoreCase)) {
                    oldfiles.Remove(sFilename);
                    return;
                }
            }
        }  // deleteFile

        public void saveOldFiles2Registry() {
            int n = oldfiles.Count;
            Basis.WriteRegInt(SingVar.C_REG_ADR + "\\Files", "COUNT_FILES", n);
            for (int i = 0; i < n; i++) {
                string sFile = (string)oldfiles[i];
                Basis.WriteRegString(SingVar.C_REG_ADR + "\\Files", "FILE_" + (i + 1).ToString(), sFile);
            }
        }



    }
}
