﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Win32;
using System.IO;
using System.Windows.Media.Imaging;
using System.Windows;
using HtmlWpfRtf.Common;

namespace HtmlWpfRtf {
    public class Middleware {
        private static Middleware instance = new Middleware();

        //private static string StringBuilder sb = new StringBuilder();

        private Middleware() {
        }

        public static Middleware getInstance() {
            return instance;
        }




        public static void InsertCSS_Body(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("body {");
            //sb.AppendLine(Konst.C_TAB+"font-size: 1.2rem;");
            sb.AppendLine(Konst.C_TAB + "color: rgb(2,2,2);");
            sb.AppendLine(Konst.C_TAB + "background-color:#FAFAFA;");
            sb.AppendLine(Konst.C_TAB + "font-family: 'Fira Sans', Verdana, sans-serif, Arial, Helvetica;");
            sb.AppendLine(Konst.C_TAB + "line-height: 1.6;");
            sb.AppendLine(Konst.C_TAB + "max-width: 40rem;");  // 640 Pixel
            sb.AppendLine(Konst.C_TAB + "padding:2rem;");
            sb.AppendLine(Konst.C_TAB + "margin:auto;");
            //sb.AppendLine(Konst.C_TAB + "font-weight: 400;");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("img {");
            sb.AppendLine(Konst.C_TAB + "max-width: 100 %;");
            sb.AppendLine("}");

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("a {");
            sb.AppendLine(Konst.C_TAB + "color:#FF4444;");
            sb.AppendLine("}");

            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("h1,h2, strong {");
            sb.AppendLine(Konst.C_TAB + "color:#010101;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("xx {");
            sb.AppendLine(Konst.C_TAB + "font-family : Arial, Helvetica, Verdana, sans-serif;");
            sb.AppendLine(Konst.C_TAB + "font-size: 1.4rem;");
            sb.AppendLine(Konst.C_TAB + "color: #0000FF;");
            sb.AppendLine(Konst.C_TAB + "font-weight : normal;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_H2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("h2{");
            sb.AppendLine(Konst.C_TAB + "font-size: 1.2rem;");
            sb.AppendLine(Konst.C_TAB + "color: #0000FF;");
            sb.AppendLine(Konst.C_TAB + "font-weight : ligther;");
            sb.AppendLine(Konst.C_TAB + "background-color: yellow;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        // nur HTML
        public static void InsertCSS_OL(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("ol{");
            sb.AppendLine(Konst.C_TAB + "list-style-type:upper-alpha;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_UL(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("ol{");
            sb.AppendLine(Konst.C_TAB + "list-style-type:square;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_TH(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("th{");
            sb.AppendLine(Konst.C_TAB + "font-family : Tahoma, Geneva, Arial, Helvetica, sans-serif;");
            sb.AppendLine(Konst.C_TAB + "font-size: 1.5rem;");
            sb.AppendLine(Konst.C_TAB + "color1: #0000FF;");
            sb.AppendLine(Konst.C_TAB + "font-weight : normal;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_TD(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("td{");
            sb.AppendLine(Konst.C_TAB + "font-family : Tahoma, Geneva, Arial, Helvetica, sans-serif;");
            sb.AppendLine(Konst.C_TAB + "font-size: 1.2rem;");
            sb.AppendLine(Konst.C_TAB + "color1: #FF00FF;");
            sb.AppendLine(Konst.C_TAB + "font-weight : normal;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertHTML_Scrolling(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<div style=\"overflow: auto; width: 100px; height: 100px; \">");
            sb.AppendLine(Konst.C_TAB + "<!-- Inhalt ->");
            sb.AppendLine("</div>");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_PositionAbsolute(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "position: absolute;");
            sb.AppendLine(Konst.C_TAB + "top: 50px;");
            sb.AppendLine(Konst.C_TAB + "left: 5;");
            sb.AppendLine(Konst.C_TAB + "width: 250px;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_PositionRelativ(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "position: relative;");
            sb.AppendLine(Konst.C_TAB + "top: 50px;");
            sb.AppendLine(Konst.C_TAB + "left: 5;");
            sb.AppendLine(Konst.C_TAB + "width: 250px;");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_Multidefinition(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("h1, h2 {");
            sb.AppendLine(Konst.C_TAB + "color: #0000FF;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_SelektorenBehind(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("body > h2 {");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_SelektorenTopDown(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("h1 + h2 {");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_LeftRightSelektor(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("/*  <div id=\"left\">  */");
            sb.AppendLine("#left{");
            sb.AppendLine(Konst.C_TAB + "float: left;");
            sb.AppendLine(Konst.C_TAB + "top: 0;");
            sb.AppendLine(Konst.C_TAB + "left: 0;");
            sb.AppendLine(Konst.C_TAB + "width: 11rem;");
            sb.AppendLine(Konst.C_TAB + "height:1000px;");
            sb.AppendLine(Konst.C_TAB + "border: 1px solid black;");
            sb.AppendLine("}");
            sb.AppendLine("");

            sb.AppendLine("/*  <div id=\"right\">  */");
            sb.AppendLine("#right{");
            sb.AppendLine(Konst.C_TAB + "right:100%");
            sb.AppendLine(Konst.C_TAB + "height:1000px;");
            sb.AppendLine(Konst.C_TAB + "width: 300px;");
            sb.AppendLine(Konst.C_TAB + "padding-left: 10px;");
            sb.AppendLine(Konst.C_TAB + "margin-left: 11.2rem;");
            sb.AppendLine(Konst.C_TAB + "border: 1px inset  black;");
            sb.AppendLine("}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_background_image(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "background-image=url(\"bild.jpg\");");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_Body_backgroundrepeat(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "background-repeat:no-repeat;  /* repeat-x  repeat-y repeat */");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Bodybackgroundattachment(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "background-attachment:scroll;  /* scroll  fixed=bleibt beim scrollen fixed */");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Body_backgroundposition(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "background-position:left;  /* left center right top bottom,   w% x% y% z%, 0.3rem */");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_ColorConstant(MyTextBox editor) {
            WSelectColorConstant colorDlg = new WSelectColorConstant();
            colorDlg.ShowDialog();
            if (colorDlg.RetCode) {
                string sColor = colorDlg.SelectedColor;
                editor.InsertText("\tcolor:" + sColor + ";");
            }
        }



        public static void InsertCSS_BackgroundColor(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "background-color: gray;");
            editor.InsertZeile(sb.ToString());
        }

        // Font

        public static void InsertCSS_FontSize_12em(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: 1.2rem;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_FontColor(MyTextBox editor) {
            WColorDialog colorDlg = new WColorDialog();
            colorDlg.ShowDialog();
            if (colorDlg.Retcode) {
                if (colorDlg.Alpha == 255) {
                    string sColor = colorDlg.Red.ToString("x2") + colorDlg.Green.ToString("x2") + colorDlg.Blue.ToString("x2");
                    editor.InsertText("color:#" + sColor + ";");
                }
                else {
                    editor.InsertText("color:rgba(" + colorDlg.Red + "," + colorDlg.Green + "," + colorDlg.Blue +
                        "," + (colorDlg.Alpha / 255.0).ToString("#0.0").Replace(',', '.') + ");");
                }
            }
        }


        public static void InsertCSS_Fonttyp_Verdana(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-family: VERDANA,ARIAL,HELVETICA;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Fonttyp_CourierNew(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-family: COURIER NEW;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Fonttyp_Monospace(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-family: MONOSPACE;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_SmallestFont(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: xx-small;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_SmallerFont(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: -1;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_BiggerFont(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: +1;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_BigFont(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: xx-large;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_FontSize_15Em(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: 1.5rem;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Bigger_Percentage(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-size: 150%;");
            editor.InsertZeile(sb.ToString());
        }




        public static void InsertCSS_FontWeight(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-weight:bold;  /* 100 bis 900 */");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_WordSpacing(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "word-spacing:2pt;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_LetterSpacing(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "letter-spacing:3pt;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Textdecoration_None(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-decoration: none;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Textdecoration_Underline(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-decoration: underline;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Textdecoration_Overline(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-decoration: overline;");
            editor.InsertZeile(sb.ToString());
        }

        //public static void InsertCSS_Textdecoration_linethrough(MyTextBox editor)
        //{
        //    StringBuilder sb = new StringBuilder();
        //    sb.AppendLine(Konstanten.C_TAB+"text-decoration: line-through;");            
        //    editor.InsertZeile( sb.ToString() );
        //}

        public static void InsertCSS_Textdecoration_blink(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-decoration:blink");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Textdecoration_Italic(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "font-style:italic;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_TextTransform_none(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-transform: none;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_TextTransform_uppercase(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-transform: uppercase;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_TextTransform_lowercase(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-transform: lowercase;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_TextTransform_capitalize(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-transform: capitalize;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Text_Indent(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-indent: 1.0in;");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_Textalign_left(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-align: left;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Textalign_center(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-align:center;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Textalign_right(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-align:right;");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_Valign_baseline(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align: baseline;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_Sub(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:sub;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_Super(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:super;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_Sub03em(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:-0.3rem;");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_VAlign_Sup03em(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:+0.3rem;");
            editor.InsertZeile(sb.ToString());
        }







        public static void InsertCSS_Valign_texttop(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:text-top;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_textbottom(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:text-bottom;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_middle(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:middle;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_top(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:top;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_bottom(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align:bottom;");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Valign_percentage(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "vertical-align: 20%;  /*  -20%  oder +20% */");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_FieldsetLegend(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("fieldset {");
            sb.AppendLine(Konst.C_TAB + "border: 2px solid #C5D8E1;");
            sb.AppendLine(Konst.C_TAB + "border-radius: 10px;");
            sb.AppendLine(Konst.C_TAB + "background: white;");
            sb.AppendLine(Konst.C_TAB + "margin: 0;");
            sb.AppendLine(Konst.C_TAB + "width:23rem;");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine("legend { ");
            sb.AppendLine(Konst.C_TAB + "color:red;");
            sb.AppendLine("} ");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertCSS_Input_required(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("input:required {");
            sb.AppendLine(Konst.C_TAB + "border: solid 2px black;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_Input_invalid(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("input:invalid {");
            sb.AppendLine(Konst.C_TAB + "border: solid 2px red;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        // FlexLayout


        public static void InsertCSS__DisplayFlex(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "display:flex;");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_Direction(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "flex-direction: row;  /* row | row-reverse | column | column-reverse;  */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_Wrap(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "flex-wrap: nowrap; /* nowrap  | wrap | wrap-reverse;  */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_justify_content(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "justify-content:flex-start;   /*  flex-start | flex-end | center | space-between | space-around | space-evenly;  */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_align_items(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "align-items:stretch;   /*  flex-start | flex-end | center | baseline | stretch;  */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_align_content(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "align-content:stretch;    /*  flex-start | flex-end | center | space-between | space-around | stretch;  */");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_FlexLayout_flex_basis(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "flex-basis: 20%;   /* <length> | auto; /* default auto */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_flex_grow(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "flex-grow: 1;    /*  1 5 2  */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_FlexLayout_flex_shrink(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "flex-shrink: 1;    /* 1 5 2 */");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_mnInsertCSS_FlexLayout_align_self(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "align-self:flex-start;   /*  auto | flex-start | flex-end | center | baseline | stretch;  */");
            editor.InsertZeile(sb.ToString());
        }


        // GridlayoutGridlayout
        public static void InsertForm_InsertForm_Gridlayout1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<div id=\"wrapperdialog\">");

            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<label class=\"column1\"  for=\"t1Id\">input1</label>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input type=\"text\" class=\"column2\" name=\"t1\" id=\"t1Id\" value=\"abc\" size=\"12\" />");

            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<label class=\"column1\"  for=\"t2Id\">input2*********</label>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input type=\"text\" class=\"column2\" name=\"t2\" id=\"t2Id\" value=\"123\" size=\"12\" />");

            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<label class=\"column1\"  for=\"t3Id\">input3</label>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input type=\"text\" class=\"column2\" name=\"t3\" id=\"t3Id\" value=\"123\" size=\"12\" />");

            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</div>");
            editor.InsertZeile(sb.ToString());

        }

        public static void InsertForm_InsertForm_Flexlayout1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<div class=\"flexContainer1\">");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<div class=\"flexContainer2\">");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<label class=\"fbox\" for=\"input1\">input1</label>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input class=\"fbox\" type=\"text\" id=\"input1\"  name=\"input1\"  value=\"12\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</div>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<div class=\"flexContainer2\">");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<label class=\"fbox\" for=\"input2\">input2</label>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input class=\"fbox\" type=\"text\" id=\"input2\"  name=\"input2\"  value=\"34\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</div>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</div>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertForm_InsertForm_Flexlayout2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<div class=\"flexContainer1\">");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<div class=\"flexContainer2\">");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input class=\"labelinput\" type=\"text\"    value=\"input1\" size=\"14\" readonly=\"readonly\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input class=\"labelinput\" type=\"text\"    value=\"input2\" size=\"14\" readonly=\"readonly\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</div>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<div class=\"flexContainer2\">");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input class=\"fbox\" type=\"text\"   name=\"input2\"  value=\"12\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input class=\"fbox\" type=\"text\"   name=\"input1\"  value=\"34\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</div>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</div>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Gridlayout1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "# wrapper {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "display: grid;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-columns: 10rem auto 10rem;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-template-rows: auto;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column-gap: 5px;  /* nur zwischen den Elementen oder bei den Bereichen mit margin */");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row-gap: 5px;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color:yellow;");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + ".aussehen {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "margin: 5px;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border: 2px ridge #C5D8E1;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "border-radius: 10px;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "header {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: deepskyblue;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 1;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "section {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: orange;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 2;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "min-height: 150px;  /* EINE Höhe reicht aus !!!  */");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "aside {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background-color: limegreen;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-column: 3;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "grid-row: 1;");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Gridlayout2(MyTextBox editor) {
        }
        public static void InsertCSS_Gridlayout3(MyTextBox editor) {
        }


        // GridlayoutGridlayout
        public static void InsertCSS_GridlayoutDialog(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("#wrapperdialog {");
            sb.AppendLine(Konst.C_TAB + "/*  2fr 4fr ==> das verhältnis zwischen den Spalten ist 2:4*/");
            sb.AppendLine(Konst.C_TAB + "display: grid;");
            sb.AppendLine(Konst.C_TAB + "grid-template-columns: auto 1fr;");
            sb.AppendLine(Konst.C_TAB + "grid-template-rows: auto auto auto;");
            sb.AppendLine(Konst.C_TAB + "grid-column-gap: 10px;");
            sb.AppendLine(Konst.C_TAB + "grid-row-gap: 10px;");
            sb.AppendLine(Konst.C_TAB + "background-color:yellow;");
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine(".column1 {");
            sb.AppendLine(Konst.C_TAB + "color:blue;");
            sb.AppendLine();
            sb.AppendLine("}");
            sb.AppendLine("");
            sb.AppendLine(".column2 {");
            sb.AppendLine(Konst.C_TAB + "margin-right:5px;");
            sb.AppendLine("}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        // xxxxxxxxxxxx
        public static void InsertCSS_Flexlayout1a(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".flexContainer1 {");
            sb.AppendLine(Konst.C_TAB + "display: flex;");
            sb.AppendLine(Konst.C_TAB + "flex-direction: column;");
            sb.AppendLine("}");
            sb.AppendLine("");

            sb.AppendLine(".flexContainer2 {");
            sb.AppendLine(Konst.C_TAB + "display: flex;");
            sb.AppendLine(Konst.C_TAB + "flex-direction: row;");
            sb.AppendLine(Konst.C_TAB + "align-items: baseline;");
            sb.AppendLine("}");
            sb.AppendLine("");

            sb.AppendLine(".fbox {");
            sb.AppendLine(Konst.C_TAB + "bborder:solid 2px blue;");
            sb.AppendLine(Konst.C_TAB + "width:10rem;");
            sb.AppendLine(Konst.C_TAB + "margin:0.5rem;");
            sb.AppendLine("}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_Flexlayout2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".flexContainer1 {");
            sb.AppendLine(Konst.C_TAB + "display: flex;");
            sb.AppendLine(Konst.C_TAB + "flex-direction: row;");
            sb.AppendLine("}");
            sb.AppendLine("");

            sb.AppendLine(".flexContainer2 {");
            sb.AppendLine(Konst.C_TAB + "display: flex;");
            sb.AppendLine(Konst.C_TAB + "flex-direction: column;");
            // sb.AppendLine(Konst.C_TAB + "align-items: baseline;");
            sb.AppendLine("}");
            sb.AppendLine("");

            sb.AppendLine(".fbox {");
            sb.AppendLine(Konst.C_TAB + "bborder:solid 2px blue;");
            sb.AppendLine(Konst.C_TAB + "width:10rem;");
            sb.AppendLine(Konst.C_TAB + "margin:0.5rem;");
            sb.AppendLine("}");
            sb.AppendLine("");

            sb.AppendLine(".labelinput {");
            sb.AppendLine(Konst.C_TAB + "border: none;");
            sb.AppendLine(Konst.C_TAB + "background-color:#FAFAFA;");
            sb.AppendLine(Konst.C_TAB + "margin:0.5rem;");        
            sb.AppendLine("}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }

        // ----------------------------------------------------------

        public static void InsertCSS_Textalign_justify(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "text-align:justify; /* Blocksatz */");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_UL_liste_None(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: none;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_UL_Liste_circle(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: circle;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_UL_Liste_square(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: square;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_UL_Liste_disc(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: disc;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_None(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: none;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_decimal(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: decimal;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_decimalleadingzero(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: decimal-leading-zero;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_lowerroman(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: lower-roman;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_upperroman(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: upper-roman;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_lowergreek(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: lower-greek;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_lowerlatin(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: lower-latin;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_OL_Liste_Upperlatin(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-type: upper-latin;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_ListStylePosition_inside(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-position: inside;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_ListStylePosition_outside(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "list-style-position: outside;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_BlockTR(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("th {");
            sb.AppendLine(Konst.C_TAB + "color1: #FF00FF;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_BlockTH(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("th {");
            sb.AppendLine(Konst.C_TAB + "font-family : Arial, Helvetica, Verdana, sans-serif;");
            sb.AppendLine(Konst.C_TAB + "font-size: 1.5rem;");
            sb.AppendLine(Konst.C_TAB + "color1: #0000FF;");
            sb.AppendLine(Konst.C_TAB + "font-weight : normal;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_BlockTD(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("td {");
            sb.AppendLine(Konst.C_TAB + "font-family : Arial, Helvetica, Verdana, sans-serif;");
            sb.AppendLine(Konst.C_TAB + "font-size: 1.1rem;");
            sb.AppendLine(Konst.C_TAB + "color1: #FF00FF;");
            sb.AppendLine(Konst.C_TAB + "font-weight : normal;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_Table_th_td_Border(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("/* Aussenrand */");
            sb.AppendLine("table {");
            sb.AppendLine(Konst.C_TAB + "border: 1px solid; ");
            sb.AppendLine(Konst.C_TAB + "border-collapse:collapse; /* verhindert doppelte Ränder */ ");
            sb.AppendLine("}");

            sb.AppendLine("");
            sb.AppendLine("/* einfacher Rand in der Tabelle */");
            sb.AppendLine("td, th {");
            sb.AppendLine(Konst.C_TAB + "border: 1px solid; ");
            sb.AppendLine(Konst.C_TAB + "border-color: black;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_Table_css_hover(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine("thead {");
            sb.AppendLine(Konst.C_TAB + "border:1px solid;");
            sb.AppendLine(Konst.C_TAB + "color:blue;");
            sb.AppendLine(Konst.C_TAB + "text-align:right;");
            sb.AppendLine(Konst.C_TAB + "background-color:yellow;");
            sb.AppendLine("}");


            sb.AppendLine("tbody tr:nth-child(odd) td {");
            sb.AppendLine(Konst.C_TAB + "background-color:#CCFFFF;");
            sb.AppendLine("}");
            sb.AppendLine();

            sb.AppendLine("tbody tr:nth-child(even) td {");
            sb.AppendLine(Konst.C_TAB + "background-color:lightgreen;");
            sb.AppendLine("}");
            sb.AppendLine();


            sb.AppendLine("tbody tr:hover:nth-child(odd) td {");
            sb.AppendLine(Konst.C_TAB + "background-color:gray;");
            sb.AppendLine(Konst.C_TAB + "cursor: pointer;");
            sb.AppendLine("}");
            sb.AppendLine();

            sb.AppendLine("tbody tr:hover:nth-child(even) td {");
            sb.AppendLine(Konst.C_TAB + "background-color:yellow;");
            sb.AppendLine(Konst.C_TAB + "cursor:pointer;");
            sb.AppendLine("}");
            sb.AppendLine();

            sb.AppendLine("tfoot {");
            sb.AppendLine(Konst.C_TAB + "border: 1px solid;");
            sb.AppendLine(Konst.C_TAB + "color: red;");
            sb.AppendLine(Konst.C_TAB + "text-align:center;");
            sb.AppendLine(Konst.C_TAB + "background-color: #EEEEEE;");
            sb.AppendLine("}");
            sb.AppendLine();


            editor.InsertZeile(sb.ToString());
        }




        public static void InsertCSS_Bordercolor(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-color: red;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_Border_None(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style: none;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Hidden(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style: hidden;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Dotted(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style: dotted;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Dashed(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style:dashed;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Solid(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style:solid;");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_Border_Double(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style: double;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Groove(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style:groove;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Ridge(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style:ridge;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Inset(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style:inset;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Border_Outset(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-style:outset;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_BorderWidth(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "border-width:5px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_PaddingOneForfour(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_PaddingTwoForTwo(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding: 10px 10px;  /* T/B  und L/R */");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_PaddingFourForFour(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding: 10px 10px 10px 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_PaddingTop(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding-top: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_PaddingLeft(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding-left: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_PaddingBottom(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding-bottom: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_Paddingright(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "padding-right: 10px;;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginOneForFour(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginTwoForTwo(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin: 10px 10px;  /* oder 10px  auto;  */");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginFourForFour(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin: 10px 10px 10px 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginTop(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin-top: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginLeft(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin-left: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginBottom(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin-bottom: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_MarginRight(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "margin-right: 10px;");            
            editor.InsertZeile( sb.ToString() );
        }
                        


            
        public static void InsertCSS_Links_NoneVisited(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("a:link{");
            sb.AppendLine(Konst.C_TAB + "color: #0000FF;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertCSS_Links_Visited(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("a:visited{");
            sb.AppendLine(Konst.C_TAB + "color: #00FF00;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertCSS_Links_Activate(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("a:active{");
            sb.AppendLine(Konst.C_TAB + "color: #FF0000;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertCSS_Links_ThreeLinks(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("a:link{");            
            sb.AppendLine(Konst.C_TAB + "color: #0000FF;");            
            sb.AppendLine("}");            
            sb.AppendLine("");            
            sb.AppendLine("a:visited{");            
            sb.AppendLine(Konst.C_TAB + "color: #00FF00;");            
            sb.AppendLine("}");            
            sb.AppendLine("");            
            sb.AppendLine("a:active{");            
            sb.AppendLine(Konst.C_TAB + "color: #FF0000;");            
            sb.AppendLine("}");            
            sb.AppendLine("");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertCSS_Links_ThreeLinksTogether(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("a:link, a:visited, a:active{");
            sb.AppendLine(Konst.C_TAB + "color: #FF0000;");
            sb.AppendLine(Konst.C_TAB + "  /*text-decoration:none;*/");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

 //   HTML
        public static void InsertHTML_HTML5_strict11(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            // sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<!DOCTYPE html");
            sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" >");
            sb.AppendLine(Konst.C_TAB + "<head>");
            sb.AppendLine(Konst.C_TAB+ Konst.C_TAB+"<title> Beispiel 1 </title>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB +"<meta name=\"author\" content=\"Administrator\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB +"<meta charset=\"utf-8\"/>");
            sb.AppendLine(Konst.C_TAB +"</head>");
            sb.AppendLine(Konst.C_TAB + "<body>");  
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<h1>Überschrift</h1>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<section>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"<header>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"</header>");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<footer>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"</footer>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</section>");
            sb.AppendLine(Konst.C_TAB + "</body>");
            sb.AppendLine("</html>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertHTML_Basic_XHTML_strict11(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.AppendLine("<!DOCTYPE html");
            sb.AppendLine("     PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\"");
            sb.AppendLine("    \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
            sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
            sb.AppendLine(Konst.C_TAB + "<head>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<title> Beispiel 1 </title>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"/>");
            sb.AppendLine(Konst.C_TAB + "</head>");
            sb.AppendLine(Konst.C_TAB + "<body>");  //  xmlns="http://www.w3.org/1999/xhtml"
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<h1>Überschrift</h1>");
            sb.AppendLine(Konst.C_TAB + "</body>");
            sb.AppendLine("</html>");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertHTML_Basic_XHTML(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<?xml version=\"1.0\" ?>");
            sb.AppendLine("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"");
            sb.AppendLine("        \"http://www.w3.org/TR/html4/strict.dtd\">");
            sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
            sb.AppendLine(Konst.C_TAB +"<head>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<title> Beispiel 1 </title>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"/>");
            sb.AppendLine(Konst.C_TAB + "</head>");
            sb.AppendLine(Konst.C_TAB + "<body>");
            sb.AppendLine(Konst.C_TAB + "<h1>Überschrift</h1>");
            sb.AppendLine(Konst.C_TAB + "</body>");
            sb.AppendLine("</html>");
            editor.InsertZeile( sb.ToString() );
        }
        public static void InsertHTML_HTML4(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\"");
            sb.AppendLine("          \"http://www.w3.org/TR/html4/loose.dtd\">");
            sb.AppendLine("<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">");
            sb.AppendLine(Konst.C_TAB + "<head>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<title> Beispiel 1 </title>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta name=\"author\" content=\"Administrator\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<meta http-equiv=\"content-type\" content=\"text/html; charset=ISO-8859-1\"/>");
            sb.AppendLine(Konst.C_TAB + "</head>");
            sb.AppendLine(Konst.C_TAB + "<body>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<h1>Überschrift</h1>");
            sb.AppendLine(Konst.C_TAB + "</body>");
            sb.AppendLine("</html>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertHTML_Basic_Pur(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<html>");
            sb.AppendLine(Konst.C_TAB +"<head>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<title> Beispiel 1 </title>");
            sb.AppendLine(Konst.C_TAB + "</head>");
            sb.AppendLine(Konst.C_TAB + "<body>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<p>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "1. Zeile");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</p>");
            sb.AppendLine(Konst.C_TAB + "</body>");
            sb.AppendLine("</html>");
            editor.InsertZeile( sb.ToString() );
        }

                        
              
        public static void InsertHTML_Header1_6(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<h1>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Text H1");            
            sb.AppendLine(Konst.C_TAB + "</h1>");            
            editor.InsertZeile( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Paragraph(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<p>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Text p");            
            sb.AppendLine(Konst.C_TAB + "</p>");            
            editor.InsertZeile( sb.ToString() );
        }
                        
             
             
        public static void InsertHTML_UL(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<ul>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<li>Text1</li>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<li>Text2</li>");
            sb.AppendLine(Konst.C_TAB + "</ul>");            
            editor.InsertZeile( sb.ToString() );
        }
                        
        public static void InsertHTML_OL(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<ol>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<li>Text1</li>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<li>Text2</li>");
            sb.AppendLine(Konst.C_TAB + "</ol>");            
            editor.InsertZeile( sb.ToString() );
        }
                      
        public static String createTable(int AnzRow, int AnzCol, 
                  bool bHeaderInFirstRow, bool bHeaderInFirstCol,
                  bool bHead, bool bBody, bool bFoot, bool bCellSpacing, bool bCellPadding, bool bMitColGroup,
                  int iCellFrame) {
            int nr, c, r;
            string sTable;
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<!-- Table -->");
            sTable= Konst.C_TAB + "<table ";
            if (bCellSpacing) sTable += " cellspacing=\"20\" ";  // cellspacing="10"
            if (bCellPadding) sTable += " cellpadding=\"20%\" ";
            switch (iCellFrame) {
                case 1: sTable += "frame=\"no\" ";
                    break;
                case 2: sTable += "frame=\"above\" ";
                    break;
                case 3: sTable += "frame=\"below\" ";
                        break;
                case 4: sTable += "frame=\"hsided\" rules=\"rows\" ";
                        break;
                case 5: sTable += "frame=\"vsided\" rules=\"cols\" ";
                        break;
                case 6: sTable += "frame=\"lhs\" ";
                        break;
                case 7: sTable += "frame=\"rhs\"  ";
                        break;
                case 8: sTable += "frame=\"box\" ";
                        break;
                case 9: sTable += "frame=\"border\" ";
                        break;
            }
            sb.AppendLine(sTable+">");
            if (bMitColGroup) {
               sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<colgroup>");
               for (c=0; c<AnzCol; c++) {
                 sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<col width=\"80\"/>");
               }
               sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</colgroup>");
            }
                        
            if (bHead) {
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<thead>");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<tr>");
                for (c = 0; c < AnzCol; c++)
                {
                    sb.AppendLine( Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<th> " + "thead-"+(c+1)  +"</th>");
                }
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</tr>");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</thead>");
            }

            nr=0;
            
            if (bBody) sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<tbody>");
            for (r=1; r<=AnzRow; r++) {                
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<tr>");
                for (c=1; c<=AnzCol; c++) {
                    nr++;
                    if ((c == 1) && bHeaderInFirstCol) {
                        if ((r == 1) && bHeaderInFirstCol)
                            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<th>" + "th-" + (r+c) + "</th>");
                        else 
                            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<th> " +nr.ToString()+"-zelle</th>");
                    }
                    else {
                        if ((r == 1) && bHeaderInFirstRow) 
                            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<th>" + "th-" + (r+c) + " </th>");
                        else 
                            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<td> " +nr.ToString()+"-zelle</td>");
                    }
                }  // for (c=0; c<AnzCol; c++) {                  
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</tr>");
            }  // for (r=0; r<AnzRow; r++) {                
            if (bBody) sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</tbody>");

         
            if (bFoot) {
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB +"<tfoot>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<tr>");
            for (c = 0; c < AnzCol; c++)
            {
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<td>" + "tfoot-" + (c) + "</td>");
            }
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</tr>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</tfoot>");
            }
            sb.AppendLine(Konst.C_TAB + "</table>");
            return sb.ToString();              
        }  // createTable


        public static void InsertHTML_Table(MyTextBox editor)  {
            WInsertHTMLTable dialog = new WInsertHTMLTable();
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String table = createTable(dialog.AnzRow, dialog.AnzCol, dialog.HeaderInFirstRow, dialog.HeaderInFirstCol,
                    dialog.Head, dialog.Body, dialog.Foot, 
                    dialog.CellSpacing, dialog.CellPadding,  dialog.Colgroup, dialog.CellFrame);
                editor.InsertZeile(table);
            }
        }
                        

        public static void InsertHTML_TR(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<tr>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<td>Text1</td>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<td>Text2</td>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</tr>");            
            editor.InsertZeile( sb.ToString() );
        }
                        
              
        public static void InsertHTML_HR(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<hr  />");            
            editor.InsertZeile( sb.ToString() );
        }
                        
                        
              
        public static void InsertHTML_EMailLink(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"mailto:\"> Adresse </a>" );
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Link(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"bsp.xhtml\">   text  </a>");            
            editor.InsertZeile( sb.ToString() );
        }
                        
            
        public static void InsertHTML_Anchor(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a name=\"\"> </a>");
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Comment(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<!--  Kommentar -->");            
            editor.InsertZeile( sb.ToString() );
        }
                        



              
        public static void InsertHTML_Font_Bold(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<strong>  </strong>");            
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Font_Italic(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<i>  </i>");            
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Font_Underline(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<u>  </u>");            
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Font_LineThrough(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<s>  </s>");            
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Font_Sup(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<sup>  </sup>");            
            editor.InsertText( sb.ToString() );
        }
                        
              
        public static void InsertHTML_Font_Sub(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<sub>  </sub>");            
            editor.InsertText( sb.ToString() );
        }
                        
              
              

        public static void InsertHTML_Font_Char(MyTextBox editor, String input) {
            editor.InsertText( input);
        }



        public static void InsertHTML_CSSReferenzExtern(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  <!--  Muss in den Header-Abschnitt -->");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<link rel=\"stylesheet\" type=\"text/css\"   href=\"style_bsp.css\" title=\"style1\"/>  ");            
            sb.AppendLine("  ");            
            editor.InsertZeile( sb.ToString() );
        }

    
              
        public static void InsertHTML_CSSReferenzLocal(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<!--  Muss in den Header-Abschnitt -->  ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<style type=\"text/css\"  id=\"internalStyle\" >  ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "body {  ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "font-size: 1rem;");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "color: rgb(255,100,100);  ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "font-weight:300;  ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</style>  ");            
            sb.AppendLine("  ");            
            editor.InsertZeile( sb.ToString() );
        }




        public static void InsertCSS_HTML5_Header(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("header{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_HTML5_Nav(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("nav{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_HTML5_Section(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("section{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertCSS_HTML5_Aside(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("aside{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_HTML5_Footer(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("footer{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_HTML5_Article(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("article{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        internal static void InsertCSS_HTML5_Required(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("input:required{");
            sb.AppendLine(Konst.C_TAB + "border:2px solid black;");
            sb.AppendLine("}");
            sb.AppendLine("input:invalid{");
            sb.AppendLine(Konst.C_TAB + "background-image:url(\"error.png\");");
            sb.AppendLine(Konst.C_TAB + "background-position:right;");
            sb.AppendLine(Konst.C_TAB + "background-repeat:no-repeat;");
            sb.AppendLine(Konst.C_TAB + "border:2px solid red;  ");
            sb.AppendLine("}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertCSS_HTML5_item(MyTextBox editor, String item) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(item+"{");
            sb.AppendLine("   ");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertCSS_HTML5_InsertTransition(MyTextBox editor, String transition_timing_function) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".box:hover {");
            sb.AppendLine(Konst.C_TAB + "transition-property:font-size");
            sb.AppendLine(Konst.C_TAB + "transition-duration:5s;");
            sb.AppendLine(Konst.C_TAB + "transition-timing-function:" + transition_timing_function+";");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "font-size:3rem;");
            sb.AppendLine("}");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertCSS_HTML5_InsertAnimationBlock(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  animation-delay:8s;");
            sb.AppendLine("  animation-duration: 7s;");
            sb.AppendLine("  animation-timing-function: linear ;  /* ease, ease-in, ease-out, ease-in-out, linear  */");
            sb.AppendLine("  animation-iteration-count:1; /* 1, 1.5, infinite  */");
            sb.AppendLine("  animation-direction:normal; /* normal,reverse,alternate, alternate-reverse,alternate-reverse  */");
            sb.AppendLine("  /* Which values are guilty at the end; */");
            sb.AppendLine("  animation-fill-mode:none; /* none|forwards|backwards|both|initial|inherit; */");
            sb.AppendLine("  animation-name: imagetext;");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_HTML5_InsertkeyframesFromTo(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("@keyframes myID{");
            sb.AppendLine(Konst.C_TAB + "from {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "width: 10px; ");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "to {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "width: 350px;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertCSS_HTML5_InsertkeyframesProzent(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("@keyframes myID{");
            sb.AppendLine(Konst.C_TAB + "0% {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background:white;");
            sb.AppendLine(Konst.C_TAB + "}  ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "33% {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background:yellow;");
            sb.AppendLine(Konst.C_TAB + "}  ");
            sb.AppendLine(Konst.C_TAB + "66% {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background:green;");
            sb.AppendLine(Konst.C_TAB + "}  ");
            sb.AppendLine(Konst.C_TAB + "100% {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "background:black;");
            sb.AppendLine(Konst.C_TAB + "}  ");
            sb.AppendLine("}    ");
            editor.InsertZeile(sb.ToString());
        }


        public static void CSS_HTML5_Transform_Rotate(MyTextBox editor) {
            editor.InsertText( "transform:rotate(23.5deg);" );
        }

            
        public static void CSS_HTML5_Transform_TranslateX(MyTextBox editor) {
            editor.InsertText( "transform:translateX(3px);" );
        }
        public static void CSS_HTML5_Transform_TranslateY(MyTextBox editor) {
            editor.InsertText( "transform:translateY(3px);" );
        }
        public static void CSS_HTML5_Transform_TranslateXY(MyTextBox editor) {
            editor.InsertText( "transform:translateX(3px,1px);" );
        }

        public static void CSS_HTML5_Transform_ScaleX(MyTextBox editor) {
            editor.InsertText( "transform:scaleX(1.3);" );
        }
        public static void CSS_HTML5_Transform_ScaleY(MyTextBox editor) {
            editor.InsertText( "transform:scaleY(1.5);" );
        }
        public static void CSS_HTML5_Transform_ScaleXY(MyTextBox editor) {
            editor.InsertText( "transform:scale(1.2, 1.6);" );
        }


        public static void CSS_HTML5_Transform_SkewX(MyTextBox editor) {
            editor.InsertText( "transform:skewX(1.3deg);" );
        }
        public static void CSS_HTML5_Transform_SkewY(MyTextBox editor) {
            editor.InsertText( "transform:skewX(1.3deg);" );
        }
        public static void CSS_HTML5_Transform_SkewXY(MyTextBox editor) {
            editor.InsertText( "transform:skew(1.2deg, 1.3deg);" );
        }


        public static void InsertCSS_HTML5_Gradient(MyTextBox editor, String gradient) {
            editor.InsertText(gradient);
        }


        // --------------


        public static void InsertForm_Formrange1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<form>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</form>");
            editor.InsertZeile( sb.ToString() );
        }
        public static void InsertForm_Formrange2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<form method=\"get\" action=\"test.php\" >");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</form>");
            editor.InsertZeile( sb.ToString() );
        }
                        
              
        public static void InsertForm_FieldsetLegend(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<fieldset>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<legend>Überschrift</legend>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</fieldset>");            
            editor.InsertZeile( sb.ToString() );
        }

        //  xxxxxxxxxxxxx



        public static void InsertForm_Label(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<label for=\"userId\" > Username  ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<!-- insert a form element -->  ");            
            sb.AppendLine(Konst.C_TAB + "<input type=\"text\" name=\"inputText\"  id=\"userId\" value=\"Vorgabetext\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\"  />");
            sb.AppendLine(Konst.C_TAB + "</label>  ");            
            sb.AppendLine(Konst.C_TAB + "<br />");            
            sb.AppendLine(Konst.C_TAB + "<br />");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }
                    



        public static void InsertForm_Textfeld1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"text\" name=\"name1\" value=\"Vorgabetext\" size=\"12\" />");
            editor.InsertZeile( sb.ToString() );
        }
        public static void InsertForm_Textfeld2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"text\" name=\"name1\" placeholder=\"Vorgabetext(placeholder)\" value=\"Vorgabetext\" size=\"12\"   autofocus=\"autofocus\"  required=\"required\"/>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertForm_Password(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"password\" name=\"name1\" value=\"Vorgabetext\" size=\"12\" />");
            editor.InsertZeile(sb.ToString());
        }  


        
        public static void InsertForm_div_ajax(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<div id=\"ajax\"></di>");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertForm_TextfeldPattern(MyTextBox editor){
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<!--  IP-Address  pattern=\"[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}\" --> ");
            sb.AppendLine(Konst.C_TAB + "<!--  Name-pattern: pattern=\"[A-Z][a-z]{1,30}\" --> ");            
            sb.AppendLine(Konst.C_TAB + "<input type=\"text\" name=\"name1\" placeholder=\"Vorgabetext(placeholder)\" pattern=\"[0-9]{1,3}.[0-9]{1,3}.[0-9]{1,3}\" value=\"Vorgabetext\" size=\"12\"   autofocus=\"autofocus\"  required=\"required\"/>");            
            sb.AppendLine("");       
            editor.InsertZeile( sb.ToString() );
        }
                        
            
        public static void InsertForm_Textarea(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + "<!-- attribs wrap: a)off b)HARD  c)SOFT -->");
            sb.AppendLine(Konst.C_TAB + "<textarea name=\"editor\" rows=\"10\" cols=\"50\"  wrap=\"SOFT\"> Eingabe eines Textes in einem Editor</textarea>");
            editor.InsertZeile( sb.ToString() );
        }
                        
             
        public static void InsertForm_Hidden(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"hidden\" name=\"geheim\" value=\"passwort\" size=\"12\"/>");
            sb.AppendLine(Konst.C_TAB + "<textarea name=\"hiddeneditor\" rows=\"10\" cols=\"50\" style=\"display:none;\"  wrap=\"SOFT\"> Hidden</textarea>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertForm_CheckBox(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"checkbox\" name=\"cad1\" value=\"CAD1\" /> AutoCAD<br />");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertForm_MultiCheckBox(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"checkbox\" name=\"cad[]\" value=\"CAD1\" /> AutoCAD<br />");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertForm_RadioButton(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<br />");    
            sb.AppendLine(Konst.C_TAB + "<input type=\"radio\" name=\"R1\" value=\"CAD1\" checked=\"checked\" /> AutoCAD  <br />");    
            sb.AppendLine(Konst.C_TAB + "<input type=\"radio\" name=\"R1\" value=\"CAD2\"  /> TurboCAD <br />");    
            sb.AppendLine(Konst.C_TAB + "<input type=\"radio\" name=\"R1\" value=\"CAD3\"  /> Eagle<br />");    
            sb.AppendLine("");    
            editor.InsertZeile( sb.ToString() );
        }
                        
             
        public static void InsertForm_ComboBox(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<br />");            
            sb.AppendLine(Konst.C_TAB + "<select name=\"objekte\" >  <!--   size=\"6\" multiple=\"multiple\"  -->   ");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<option > Circle </option >");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<option selected=\"selected\" > Square </option >");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<option  > Polygon </option >");            
            sb.AppendLine(Konst.C_TAB + "</select>");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }
                        
             
                        
              
        public static void InsertForm_HTML5_Color(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "Colordialog: <input type=\"color\" name=\"color1\" value=\"color1\" /> <br />");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }
                        
              
        public static void InsertForm_HTML5_Date(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "1. Date: <input type=\"date\" name=\"datum1\" value=\"datum1\" /><br />");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }
                     
        // !!!!!!!!!!!
        public static void InsertForm_HTML5_Date_local(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "1. Date: <input type=\"date\" name=\"datum1\" value=\"datum1\" />");
            sb.AppendLine(Konst.C_TAB +"<br />");
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertForm_HTML5_Number(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "1. Number <input type=\"number\" name=\"zahl1\"  min=\"0\"  max=\"100\" value =\"12\" />");
            sb.AppendLine(Konst.C_TAB + "<br />");
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }
                        
              
        public static void InsertForm_HTML5_Range1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"range\" name=\"range1\" min=\"10\" max=\"100\" step=\"5\" value=\"55\" />");            
            sb.AppendLine(Konst.C_TAB + "<output name=\"range1_output\" onforminput=\"value=range1.value\"> 55 </output>");
            sb.AppendLine(Konst.C_TAB + "<br />");
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }

        // !!!!!!!!!
        public static void InsertForm_HTML5_Range2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"range\" name=\"range1\" min=\"10\" max=\"100\" step=\"5\" value=\"55\" />");            
            sb.AppendLine(Konst.C_TAB + "<output name=\"range1_output\" onforminput=\"value=range1.value\"> 55 </output>");
            sb.AppendLine(Konst.C_TAB + "<br />");
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertForm_HTML5_Meter(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "<meter id=\"meter1\" min=\"0\"  max=\"100\" value=\"25.67\" title=\"KW\" > </meter>");
        }

        
        public static void InsertForm_HTML5_Output(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "<output for=\"a b\" id=\"ergebnis\">   </output>");
        }

        
        public static void InsertForm_HTML5_Canvas(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "1. Datum: <input type=\"date\" name=\"datum1\" value=\"datum1\" />");
            sb.AppendLine(Konst.C_TAB + "<br />");
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }



        public static void InsertForm_Submit(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"submit\" value=\"Send\" />");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertForm_SubmitFormAction(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"submit\" value=\"Send\" formaction=\"page1.xhtml\" formmethod=\"get\" />");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertForm_Button(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"button\" value=\"Send\" onclick=\"calc(this.form)\"/>");            
            editor.InsertZeile( sb.ToString() );
        }
                        
             
        public static void InsertForm_Reset(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"reset\" value=\"Delete\"/>");
            sb.AppendLine(Konst.C_TAB + "<br />");
            editor.InsertZeile( sb.ToString() );
        }
        public static void InsertForm_onSubmitEvent(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            editor.InsertText(" onsubmit =\"return validation()\" ");
        }


        public static void InsertForm_CompletSample(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<form>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<fieldset>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<legend>Überschrift</legend>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<label for=\"userID\"  > Input:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input type=\"text\" name=\"inputText\"  id=\"userID\"   placeholder=\"Vorgabetext(placeholder)\" value=\"Vorgabetext\" size=\"14\" maxlength=\"10\" autofocus=\"autofocus\"  required=\"required\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "</label>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input type=\"submit\" value=\"Send\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<input type=\"reset\" value=\"Delete\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<br />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</fieldset>");
            sb.AppendLine(Konst.C_TAB + "</form>");
            sb.AppendLine("");
            editor.InsertZeile( sb.ToString() );
        }



        public static void InsertForm_HTML5_Header(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<header>");
            sb.AppendLine("");
            sb.AppendLine("</header>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertForm_HTML5_Arcticle(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<article>");
            sb.AppendLine("");
            sb.AppendLine("</article>");
            editor.InsertZeile( sb.ToString() );
        }
            

        public static void InsertForm_HTML5_Section(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<section>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<header>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</header>");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<footer>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</footer>");
            sb.AppendLine(Konst.C_TAB + "</section>");
            editor.InsertZeile( sb.ToString() );
        }
            

        public static void InsertForm_HTML5_Aside(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<h2>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Ein besonderes Angebot");
            sb.AppendLine(Konst.C_TAB + "</h2>");
            sb.AppendLine(Konst.C_TAB + "<aside id=\"angebot1\">");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<h2>Shop</h2>");
            sb.AppendLine(Konst.C_TAB + "</aside>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertForm_HTML5_Footer(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<footer>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "</footer>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertForm_HTML5_Nav_Hori(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<nav>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"link1.html\" title=\"link1\">Link1</a> |");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<a href=\"link2.html\" title=\"link2\">Link2</a>");
            sb.AppendLine(Konst.C_TAB + "</nav>");
            editor.InsertZeile(sb.ToString());
        }
            
        public static void InsertForm_HTML5_Nav_Verti(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<nav>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<ul>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"Struktur.html\" title=\"Struktur\">Struktur</a></li>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "<li><a href=\"Darstellung.html\" title=\"Darstellung\">Darstellung</a></li>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</ul>");
            sb.AppendLine(Konst.C_TAB + "</nav>");
            editor.InsertZeile(sb.ToString());
        }
            

        public static void InsertForm_HTML5_Progress(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<progress id=\"progress1\"  value=\"24\" min=\"0\"  max=\"100\" >");
            sb.AppendLine(Konst.C_TAB + "</progress>");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertForm_HTML5_Figure(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<figure> ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<img src=\"image1.png\" >");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<figurecaption>Hier steht die Beschreibung des Bildes </figurecaption>");
            sb.AppendLine(Konst.C_TAB + "</figure>");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertForm_HTML5_Datalist(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<input type=\"text\" list=\"myDatalist\">");
            sb.AppendLine(Konst.C_TAB + "<datalist id=\"myDatalist\" >");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<option value=\"Item1\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<option value=\"Item2\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<option value=\"Item3\"/>");
            sb.AppendLine(Konst.C_TAB + "</datalist>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertForm_HTML5_Datetime(MyTextBox editor) {
            editor.InsertZeile("<datetime>  </datetime>");
        }

        public static void InsertForm_HTML5_Month(MyTextBox editor) {
            editor.InsertZeile("<month>  </month>");
        }
        public static void InsertForm_HTML5_Week(MyTextBox editor) {
            editor.InsertZeile("<week>  </week>");
        }
        public static void InsertForm_HTML5_Time(MyTextBox editor) {
            editor.InsertZeile("<time>  </time>");
        }


        public static void InsertForm_HTML5_Keygen(MyTextBox editor) {
            editor.InsertZeile("<keygen>  </keygen>");
        }
        public static void InsertForm_HTML5_Tel(MyTextBox editor) {
            editor.InsertZeile("<tel>  </tel>");
        }
        public static void InsertForm_HTML5_Search(MyTextBox editor) {
            editor.InsertZeile("<search>  </search>");
        }
        public static void InsertForm_HTML5_Url(MyTextBox editor) {
            editor.InsertZeile("<url>  </url>");
        }
        public static void InsertForm_HTML5_EMail(MyTextBox editor) {
            editor.InsertZeile("<email>  </email>");
        }



        public static void InsertForm_HTML5_Video1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<video controls=\"controls\" >");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.mp4\"  type=\"video/mp4\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.ogv\"  type=\"video/ogg\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.webm\"  type=\"video/webm\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Ihr Browser unterstützt kein HTML5-Video");
            sb.AppendLine(Konst.C_TAB + "</video>");
            editor.InsertZeile( sb.ToString() );
        }

        public static void InsertForm_HTML5_Video2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<video controls=\"controls\"  autoplay=\"autoplay\" muted=\"muted\" loop=\"loop\" ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "poster=\"poster.png\" preload=\"metadata\" >");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.mp4\"  type=\"video/mp4\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.ogv\"  type=\"video/ogg\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.webm\"  type=\"video/webm\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Ihr Browser unterstützt kein HTML5-Video");
            sb.AppendLine(Konst.C_TAB + "</video>");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertForm_HTML5_Video3(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<video controls=\"controls\"  autoplay=\"autoplay\" muted=\"muted\" loop=\"loop\" ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "poster=\"poster.png\" preload=\"metadata\" >");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.mp4\"  type=\"video/mp4\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.ogv\"  type=\"video/ogg\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source src=\"myvideo.webm\"  type=\"video/webm\"/>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<track label=\"German subtitles\" kind=\"subtitles\" srclang=\"de\" src=\"/german-subtitles.vtt\" default=\"\" />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<track label=\"English subtitles\" kind=\"subtitles\" srclang=\"en\" src=\"/english-subtitles.vtt\"  />");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Ihr Browser unterstützt kein HTML5-Video");
            sb.AppendLine(Konst.C_TAB + "</video>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertForm_HTML5_Audio1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<audio controls=\"controls\" >");
            sb.AppendLine(Konst.C_TAB + "<source src=\"myaudio.mp3\"  type=\"audio/mp3\"/>");
            sb.AppendLine(Konst.C_TAB + "<source src=\"myaudio.ogv\"  type=\"audio/ogg\"/>");
            sb.AppendLine(Konst.C_TAB + "Ihr Browser unterstützt kein HTML5-Audio. Klicken Sie auf <a href=\"myaudio.mp3\" </a>");
            sb.AppendLine(Konst.C_TAB + "</audio>");
            editor.InsertZeile(sb.ToString());
        }
        
        public static void InsertForm_HTML5_Audio2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<audio controls=\"controls\"  autoplay=\"autoplay\" muted=\"muted\" loop=\"loop\"   >");
            sb.AppendLine(Konst.C_TAB + "<source src=\"myaudio.mp3\"  type=\"audio/mp3\"/>");
            sb.AppendLine(Konst.C_TAB + "<source src=\"myaudio.ogv\"  type=\"audio/ogg\"/>");
            sb.AppendLine(Konst.C_TAB + "Ihr Browser unterstützt kein HTML5-Audio. Klicken Sie auf <a href=\"myaudio.mp3\" </a>");
            sb.AppendLine(Konst.C_TAB + "</audio>");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_GameLoop1(MyTextBox editor) {
            bool mouseEventMethods = Basis.readYesNo("Canvas Element with mouse-Events?","Insert canvas");
            bool keyEventMethods = Basis.readYesNo("Canvas Element with key-Events?", "Insert canvas");
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<canvas id=\"myCanvas\" width=\"600\" height=\"300\" />");
            sb.AppendLine(Konst.C_TAB + "<script type=\"text/javascript\">");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// <![CDATA[");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
            sb.AppendLine();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let ctx;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let canvas;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let myIntervall;  ");
            if (mouseEventMethods) {
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let cssBorderWidth=3;  ");
            }
            
            sb.AppendLine();
            sb.AppendLine(Konst.C_TAB + "window.onload = function() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "canvas = document.getElementById('myCanvas');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "if (canvas.getContext) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "ctx=canvas.getContext('2d');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "console.log(canvas.width);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "window.addEventListener( 'keypress', onKeypress, false )");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// delete with clearInterval(myIntervall);");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "myIntervall = setInterval(function() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "draw();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}, 1000/30);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('Ihr Browser untertützt kein HTML5, Canvas');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            if (mouseEventMethods) {
                sb.AppendLine();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "canvas.addEventListener('mousedown', onMousedown, false );");
            }
            if (keyEventMethods) {
                sb.AppendLine();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "window.addEventListener( \"keydown\", onKeydown, false );");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "window.addEventListener( \"keypress\", onKeypress, false );");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "window.addEventListener( \"keyup\", onKeyup, false );");
            }
            sb.AppendLine(Konst.C_TAB + "}  // onload ");
            sb.AppendLine();
            sb.AppendLine(Konst.C_TAB + "function draw() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "if (canvas.getContext) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "ctx.clearRect(0,0, canvas.width,canvas.height);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}  // if (canvas.getContext) ");
            sb.AppendLine(Konst.C_TAB + "} // draw");
            sb.AppendLine();

            if (keyEventMethods) {
                insert_keyevents(sb);
            }
            if (mouseEventMethods) {
                insert_mouseevents(sb);
            }

            sb.AppendLine(Konst.C_TAB + "// ]]>");
            sb.AppendLine(Konst.C_TAB + "</script>");

            editor.InsertZeile(sb.ToString());
        }  // HTML5_Canvas_GameLoop1

        public static void insert_keyevents(StringBuilder sb) {
            sb.AppendLine("    function onKeydown(e) {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      if (e.keyCode>0) {");
            sb.AppendLine("         // Zusatzentasten");
            sb.AppendLine("         console.log(\"keyCode: \"+e.keyCode);");
            sb.AppendLine("         switch (e.keyCode) {");
            sb.AppendLine("           case 37: // Pfeil links");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 38: // Pfeil oben");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 39: // Pfeil rechts");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 40: // Pfeil unten");
            sb.AppendLine("                   break;");
            sb.AppendLine("         } // switch ");
            sb.AppendLine("      } // if keyCode");
            sb.AppendLine("      else {");
            sb.AppendLine("        console.log(\"charCode: \"+e.charCode);");
            sb.AppendLine("        switch (e.charCode) {");
            sb.AppendLine("          case 32: // Leerzeichen");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 48: // 0");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 65: // A");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 97: // a");
            sb.AppendLine("                   break;");
            sb.AppendLine("        } // switch ");
            sb.AppendLine("      } // if ");
            sb.AppendLine("    } // keydown");
            sb.AppendLine();
            sb.AppendLine("    function onKeypress(e) {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      if (e.keyCode>0) {");
            sb.AppendLine("         // Zusatzentasten");
            sb.AppendLine("         console.log(\"keyCode: \"+e.keyCode);");
            sb.AppendLine("         switch (e.keyCode) {");
            sb.AppendLine("           case 37: // Pfeil links");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 38: // Pfeil oben");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 39: // Pfeil rechts");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 40: // Pfeil unten");
            sb.AppendLine("                   break;");
            sb.AppendLine("         } // switch ");
            sb.AppendLine("      } // if keyCode");
            sb.AppendLine("      else {");
            sb.AppendLine("        console.log(\"charCode: \"+e.charCode);");
            sb.AppendLine("        switch (e.charCode) {");
            sb.AppendLine("          case 32: // Leerzeichen");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 48: // 0");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 65: // A");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 97: // a");
            sb.AppendLine("                   break;");
            sb.AppendLine("        } // switch ");
            sb.AppendLine("      } // if ");
            sb.AppendLine("    }");
            sb.AppendLine();
            sb.AppendLine("    function onKeyup(e) {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      if (e.keyCode>0) {");
            sb.AppendLine("         // Zusatzentasten");
            sb.AppendLine("         console.log(\"keyCode: \"+e.keyCode);");
            sb.AppendLine("         switch (e.keyCode) {");
            sb.AppendLine("           case 37: // Pfeil links");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 38: // Pfeil oben");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 39: // Pfeil rechts");
            sb.AppendLine("                   break;");
            sb.AppendLine("           case 40: // Pfeil unten");
            sb.AppendLine("                   break;");
            sb.AppendLine("         } // switch ");
            sb.AppendLine("      } // if keyCode");
            sb.AppendLine("      else {");
            sb.AppendLine("        console.log(\"charCode: \"+e.charCode);");
            sb.AppendLine("        switch (e.charCode) {");
            sb.AppendLine("          case 32: // Leerzeichen");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 48: // 0");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 65: // A");
            sb.AppendLine("                   break;");
            sb.AppendLine("          case 97: // a");
            sb.AppendLine("                   break;");
            sb.AppendLine("        } // switch ");
            sb.AppendLine("      } // if ");
            sb.AppendLine("    }");
            sb.AppendLine();
        }
        public static void insert_mouseevents(StringBuilder sb) {
            sb.AppendLine("    function onMousedown(e) {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("        let mouseX = e.layerX-canvas.offsetLeft-cssBorderWidth;");
            sb.AppendLine("        let mouseY = e.layerY-canvas.offsetTop-cssBorderWidth;");
            sb.AppendLine("        let message = 'MouseDown position: ' + mouseX + ',' + mouseY; ");
            sb.AppendLine("         console.log(message);");
            sb.AppendLine("    }");
            sb.AppendLine();
        }

        public static void HTML5_Canvas_GameLoop2(MyTextBox editor) {
            bool mouseEventMethods = Basis.readYesNo("Canvas Element with mouse-Events?", "Insert canvas");
            bool keyEventMethods = Basis.readYesNo("Canvas Element with key-Events?", "Insert canvas");
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  <canvas id=\"myCanvas\" width=\"600\" height=\"300\" />");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("  <script type=\"text/javascript\">");            
            sb.AppendLine("    // <![CDATA[");
            sb.AppendLine("     \"use strict\";");
            sb.AppendLine();
            sb.AppendLine("    let ctx;");
            sb.AppendLine("    let canvas;");
            sb.AppendLine("    let myIntervall;  ");
            if (mouseEventMethods) sb.AppendLine("    let cssBorderWidth=3;  ");
            sb.AppendLine("    let thenTime;");
            sb.AppendLine();
            sb.AppendLine("    window.onload = function() {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      canvas = document.getElementById('myCanvas');");
            sb.AppendLine("      if (canvas.getContext) {");
            sb.AppendLine("        ctx=canvas.getContext('2d');");
            sb.AppendLine();
            sb.AppendLine("        myIntervall = setInterval(function() {");
            sb.AppendLine("           draw();");
            sb.AppendLine("        }, 1000/30);");
            sb.AppendLine();
            sb.AppendLine("        reset();");
            sb.AppendLine("        thenTime = Date.now();");
            sb.AppendLine("        gameloop();");
            sb.AppendLine();
            if (mouseEventMethods) {
                sb.AppendLine();
                sb.AppendLine("        canvas.addEventListener('mousedown', onMousedown, false );");
            }
            if (keyEventMethods) {
                sb.AppendLine();
                sb.AppendLine("        window.addEventListener( \"keydown\", onKeydown, false );");
                sb.AppendLine("        window.addEventListener( \"keypress\", onKeypress, false );");
                sb.AppendLine("        window.addEventListener( \"keyup\", onKeyup, false );");
            }
            sb.AppendLine("       }");
            sb.AppendLine("       else {");
            sb.AppendLine("         alert('Ihr Browser untertützt kein HTML5, Canvas');");
            sb.AppendLine("       }");
            sb.AppendLine("    }  // onload ");
            sb.AppendLine();

            sb.AppendLine("    let gameloop = function () {");
            sb.AppendLine("      let now = Date.now();");
            sb.AppendLine("      let delta = now - then;");
            sb.AppendLine("      draw(delta / 1000);");
            sb.AppendLine("      thenTime = now;");
            sb.AppendLine("      requestAnimationFrame(gameloop);");
            sb.AppendLine("    };");
            sb.AppendLine();
            
            sb.AppendLine("    function reset() {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("    } // reset");
            sb.AppendLine("");
            sb.AppendLine("    function draw(deltaTime) {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      ctx.clearRect(0,0, canvas.width,canvas.height);");
            sb.AppendLine("      console.log('in draw');");            
            sb.AppendLine("    } // draw");
            sb.AppendLine();
            if (keyEventMethods) {
                insert_keyevents(sb);
            }
            if (mouseEventMethods) {
                insert_mouseevents(sb);
            }
            sb.AppendLine("  // ]]>");
            sb.AppendLine(" </script>");

            editor.InsertZeile(sb.ToString());
        }  // HTML5_Canvas_GameLoop2


        public static void HTML5_Canvas_GameLoop3(MyTextBox editor) {
            bool mouseEventMethods = Basis.readYesNo("Canvas Element with mouse-Events?", "Insert canvas");
            bool keyEventMethods = Basis.readYesNo("Canvas Element with key-Events?", "Insert canvas");
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  <div id=\"game_object\">");
            sb.AppendLine("  <canvas id=\"bg_canvas\" width=\"400\" height=\"400\" />");
            sb.AppendLine("  <canvas id=\"main_canvas\" width=\"400\" height=\"400\" />");
            sb.AppendLine("  </div>");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("  <script type=\"text/javascript\">");            
            sb.AppendLine("    // <![CDATA[");
            sb.AppendLine("     \"use strict\";");
            sb.AppendLine();
            sb.AppendLine("    let bg_ctx;");
            sb.AppendLine("    let main_ctx;");
            sb.AppendLine("    let bg_canvas;");
            sb.AppendLine("    let main_canvas;");
            sb.AppendLine("    let myIntervall;  ");
            if (mouseEventMethods) sb.AppendLine("    let cssBorderWidth=3;  ");
            sb.AppendLine("    let thenTime;");
            sb.AppendLine();
            sb.AppendLine("    window.onload = function() {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      bg_canvas = document.getElementById('bg_canvas');");
            sb.AppendLine("      main_canvas = document.getElementById('main_canvas');");
            sb.AppendLine("      if (bg_canvas.getContext  &&  main_canvas.getContext) {");
            sb.AppendLine("        bg_ctx=bg_canvas.getContext('2d');");
            sb.AppendLine("        main_ctx=main_canvas.getContext('2d');");
            sb.AppendLine();
            sb.AppendLine("        bg_ctx.fillStyle = '#CAFFFF';");
            sb.AppendLine("        bg_ctx.fillRect(0,0, bg_canvas.width, bg_canvas.height);");
            sb.AppendLine();

            sb.AppendLine("        myIntervall = setInterval(function() {");
            sb.AppendLine("           draw();");
            sb.AppendLine("        }, 1000/30);");
            sb.AppendLine();
            sb.AppendLine("        reset();");
            sb.AppendLine("        thenTime = Date.now();");
            sb.AppendLine("        gameloop();");
            sb.AppendLine();
            if (mouseEventMethods) {
                sb.AppendLine();
                sb.AppendLine("        canvas.addEventListener('mousedown', onMousedown, false );");
            }
            if (keyEventMethods) {
                sb.AppendLine();
                sb.AppendLine("        window.addEventListener( \"keydown\", onKeydown, false );");
                sb.AppendLine("        window.addEventListener( \"keypress\", onKeypress, false );");
                sb.AppendLine("        window.addEventListener( \"keyup\", onKeyup, false );");
            }
            sb.AppendLine("       }");
            sb.AppendLine("       else {");
            sb.AppendLine("         alert('Ihr Browser untertützt kein HTML5, Canvas');");
            sb.AppendLine("       }");
            sb.AppendLine("    }  // onload ");
            sb.AppendLine();

            sb.AppendLine("    let gameloop = function () {");
            sb.AppendLine("      let now = Date.now();");
            sb.AppendLine("      let delta = now - then;");
            sb.AppendLine("      draw(delta / 1000);");
            sb.AppendLine("      thenTime = now;");
            sb.AppendLine("      requestAnimationFrame(gameloop);");
            sb.AppendLine("    };");
            sb.AppendLine();

            sb.AppendLine("    function reset() {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("    } // reset");
            sb.AppendLine("");
            sb.AppendLine("    function draw(deltaTime) {");
            sb.AppendLine("      \"use strict\";");
            sb.AppendLine("      main_ctx.clearRect(0,0, main_canvas.width,main_canvas.height);");
            sb.AppendLine("      main_ctx.fillStyle = 'blue';");
            sb.AppendLine("      main_ctx.fillRect(10,10, 100, 50);");
            sb.AppendLine("      console.log('in draw');");
            sb.AppendLine("    } // draw");
            sb.AppendLine();
            if (keyEventMethods) {
                insert_keyevents(sb);
            }
            if (mouseEventMethods) {
                insert_mouseevents(sb);
            }
            sb.AppendLine("  // ]]>");
            sb.AppendLine(" </script>");

            
            sb.AppendLine();
            sb.AppendLine(" /*  CSS-Datei */");
            sb.AppendLine("#game_object {");
            sb.AppendLine("  position:relative;");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine("canvas {");
            sb.AppendLine("  position:absolute;");
            sb.AppendLine("}");
            sb.AppendLine(" /*  CSS-Datei */");

            editor.InsertZeile(sb.ToString());
            Basis.Message("Bitte kopieren Sie den CSS-Abschnitt in die CSS-Datei resp. CSS-Abschnitt", "Hinweis");
        }  // HTML5_Canvas_GameLoop3


        public static void HTML5_Canvas_Line1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.moveTo(0, 0);");
            sb.AppendLine("  ctx.lineTo(200, 100);");
            sb.AppendLine("  ctx.stroke();");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_Line2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.lineWidth = 1 + i;");
            sb.AppendLine("  ctx.strokeStyle = \"blue\";");
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.moveTo(0, 0);");
            sb.AppendLine("  ctx.lineTo(200, 100);");
            sb.AppendLine("  ctx.stroke();");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_Rect(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.lineWidth = 4;");
            sb.AppendLine("  ctx.strokeStyle = \"green\";");
            sb.AppendLine("  ctx.rect(30, 10, 150, 20);");
            sb.AppendLine("  ctx.stroke();");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_StrokeRect(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.lineWidth = 4;");
            sb.AppendLine("  ctx.strokeStyle = \"green\";");
            sb.AppendLine("  ctx.strokeRect(30, 10, 150, 20);  // ohne path");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_FillRect(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.lineWidth = 4;");
            sb.AppendLine("  ctx.strokeStyle = \"green\";");
            sb.AppendLine("  ctx.fillStyle = \"red\";");
            sb.AppendLine("  ctx.fillRect(30, 10, 150, 20);  // ohne path");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_ClearRect(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("ctx.clearRect(30, 10, 150, 20);  // ohne path");
            editor.InsertZeile(sb.ToString());
        }




        public static void HTML5_Canvas_Arc(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.lineWidth = 4;");
            sb.AppendLine("  ctx.strokeStyle = \"green\";");
            sb.AppendLine("  arc(x,y, r, alpha, Math.PI+Math.PI, anticlockwise);");
            sb.AppendLine("  ctx.stroke();");
            editor.InsertZeile(sb.ToString());
        }

        public static void HTML5_Canvas_FillArc(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.lineWidth = 2;");
            sb.AppendLine("  ctx.arc(x,y, r, 0, Math.PI+Math.PI, false);");
            sb.AppendLine("  ctx.fillStyle = 'white';");
            sb.AppendLine("  ctx.fill();");
            sb.AppendLine("  ctx.strokeStyle = 'white';");
            sb.AppendLine("  ctx.stroke();");
            sb.AppendLine("  ctx.closePath();");
            editor.InsertZeile(sb.ToString());
        }



        public static void HTML5_Canvas_StrokeText(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.font = \"24px Verdana\";");
            sb.AppendLine("  ctx.strokeStyle = \"blue\";");
            sb.AppendLine("  ctx.strokeText(\"fillText: strokeText\", 20, 150);");
            editor.InsertZeile(sb.ToString());
        }


        public static void HTML5_Canvas_FillText(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.font = \"24px Verdana\";");
            sb.AppendLine("  ctx.strokeStyle = \"blue\";");
            sb.AppendLine("  ctx.fillStyle = \"red\";");
            sb.AppendLine("  ctx.fillText(\"fillText: strokeText\", 20, 150);");
            editor.InsertZeile(sb.ToString());
        }


        public static void HTML5_Canvas_BezierCurveTo(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.moveTo(10,10);");
            sb.AppendLine("  bezierCurveTo(cp1x, cp1y, cp2x, cp2y, xEnd, yEnd);");
            sb.AppendLine("  ctx.stroke();");
            
            editor.InsertZeile(sb.ToString());
        }


        public static void HTML5_Canvas_DrawImage(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  let img = document.getElementById(\"lageplan\");");
            sb.AppendLine("  ctx.drawImage(img, 10, 10); ");
            editor.InsertZeile(sb.ToString());
        }


        public static void HTML5_Canvas_Drawmarker1(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("function drawMarker1(ctx, x, y, width) {");
            sb.AppendLine("  \"use strict\";");
            sb.AppendLine("  let w2=width*0.5;");
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.moveTo(x-w2,y-w2);");
            sb.AppendLine("  ctx.lineTo(x+w2,y+w2);");
            sb.AppendLine("  ctx.moveTo(x+w2,y-w2);");
            sb.AppendLine("  ctx.lineTo(x-w2,y+w2);");
            sb.AppendLine("  ctx.stroke();");
            sb.AppendLine("  return;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }


        public static void HTML5_Canvas_Drawmarker2(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("function drawMarker2(ctx, x, y, width) {");
            sb.AppendLine("  \"use strict\";");
            sb.AppendLine("  let w2=width*0.5;");
            sb.AppendLine("  ctx.beginPath();");
            sb.AppendLine("  ctx.moveTo(x,y-w2);");
            sb.AppendLine("  ctx.lineTo(x,y+w2);");
            sb.AppendLine("  ctx.moveTo(x-w2,y);");
            sb.AppendLine("  ctx.lineTo(x+w2,y);");
            sb.AppendLine("  ctx.stroke();");
            sb.AppendLine("  return;");
            sb.AppendLine("}");
            editor.InsertZeile(sb.ToString());
        }




        public static void InsertForm_HTML5_Address(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<address>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "</address>");
            editor.InsertZeile( sb.ToString() );
        }
            

        public static void InsertForm_HTML5_Summary(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<summary>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "</summary>");
            editor.InsertZeile( sb.ToString() );
        }
            

        public static void InsertForm_HTML5_Details(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<details>");
            sb.AppendLine("");
            sb.AppendLine(Konst.C_TAB + "</details>");
            editor.InsertZeile( sb.ToString() );
        }





        public static void InsertForm_HTML5_Video(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<video>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source  src=\"video1.mp4\"  type=\"video/mp4\">");  // h.264
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source  src=\"video1.ogv\"  type=\"video/ogg\">");  // mp
            sb.AppendLine(Konst.C_TAB + "</video>");
            editor.InsertZeile( sb.ToString());
        }

        public static void InsertForm_HTML5_Audio(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<audio>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source  src=\"audio1.mp3\"  type=\"audio/mpeg\" />");  // 
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<source  src=\"audio1.ogg\"  type=\"audio/ogg\" />");  // mp3
            sb.AppendLine(Konst.C_TAB + "</audio>");
            editor.InsertZeile( sb.ToString());
        }

        public static void InsertForm_HTML5_Abbr(MyTextBox editor) {
            editor.InsertZeile("<abbr>  </abbr>");
        }
        public static void InsertForm_HTML5_B(MyTextBox editor) {
            editor.InsertZeile("<b>  </b>");
        }
        public static void InsertForm_HTML5_Bdi(MyTextBox editor) {
            editor.InsertZeile("<bdi>  </bdi>");
        }
        public static void InsertForm_HTML5_Code(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<code>");
            sb.AppendLine("");
            sb.AppendLine("</code>");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertForm_HTML5_Cite(MyTextBox editor) {
            editor.InsertZeile("<cite>  </cite>");
        }

        public static void InsertForm_HTML5_Dl(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<dl>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<dt> Point 1</dt>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<dt> Point 2</dt>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<dd>");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "Text");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</dd>");
            sb.AppendLine(Konst.C_TAB + "</dl>");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertForm_HTML5_Del(MyTextBox editor) {
            editor.InsertZeile("<del>  </del>");
        }


        public static void InsertForm_HTML5_Em(MyTextBox editor) {
            editor.InsertZeile("<em>  </em>");
        }
        //public static void InsertForm_HTML5_Hr(MyTextBox editor) {
        //    editor.InsertZeile("<hr>");
        //}
        public static void InsertForm_HTML5_I(MyTextBox editor) {
            editor.InsertZeile("<i>  </i>");
        }
        public static void InsertForm_HTML5_Ins(MyTextBox editor) {
            editor.InsertZeile("<ins>  </ins>");
        }
        public static void InsertForm_HTML5_Kdb(MyTextBox editor) {
            editor.InsertZeile("<kdb>  </kdb>");
        }
        public static void InsertForm_HTML5_Mark(MyTextBox editor) {
            editor.InsertZeile("<mark>  </mark>");
        }
        public static void InsertForm_HTML5_Q(MyTextBox editor) {
            editor.InsertZeile("<q>  </q>");
        }
        public static void InsertForm_HTML5_S(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            editor.InsertZeile( "<s>    </s>");
        }
        public static void InsertForm_HTML5_Samp(MyTextBox editor) {
            editor.InsertZeile("<samp>  </samp>");
        }
        public static void InsertForm_HTML5_Small(MyTextBox editor) {
            editor.InsertZeile("<small>  </small>");
        }

        public static void InsertForm_HTML5_Strong(MyTextBox editor) {
            editor.InsertZeile("<strong>  </strong>");
        }


        public static void InsertForm_HTML5_U(MyTextBox editor) {
            editor.InsertZeile("<u>  </u>");
        }
        public static void InsertForm_HTML5_Var(MyTextBox editor) {
            editor.InsertZeile("<var>  </var>");
        }
        public static void InsertForm_HTML5_Wbr(MyTextBox editor) {
            editor.InsertZeile("<wbr>  </wbr>");
        }
        public static void InsertForm_HTML5_Dfn(MyTextBox editor) {
            editor.InsertZeile( "<dfn>HTML</dfn> heisst HyperText Markup Language");
        }



        public static void JavaScript_IncludeJavascript(MyTextBox editor, String filename) {
            // die lanege Varinate muss sein!
            editor.InsertZeile(Konst.C_TAB + "<script type=\"text/javascript\" src=\"" + filename+"\"></script>");
        }


              //Sci_Middleware.(scintilla);            
        public static void InsertJavaScript_InsertSector(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<script type=\"text/javascript\">");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// <![CDATA[");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");       
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "function  calc( form ) {");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert (\"here in calc\") ;");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // function calc");       
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// ]]>");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</script>");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );  
        }

        public static void JavaScript_FormArray(MyTextBox editor) {
           editor.InsertZeile("let form = document.forms[0];");
        }


        
        public static void JavaScript_FormValidation(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let valid = form.checkValidity();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (valid) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// action");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('Bitte gültige Werte eintragen');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} // validation");

            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }

        public static void JavaScript_JavaScript_validation(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "function  validation( ) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let form = document.forms[0];");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// tests");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('hier in validation');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return true;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} // validation");
            
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertJavaScript_Function(MyTextBox editor) {
            WInputString dialog = new WInputString();
            dialog.ShowDialog();            
            if (dialog.Retcode) {
                String name = dialog.NameOfFunction[0].ToString().ToLower() + dialog.NameOfFunction.Substring(1);
                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "function " + name + "() {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
                sb.AppendLine("");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
                sb.AppendLine("");
                editor.InsertZeile(sb.ToString());
            }
        }

             
        public static void InsertJavaScript_Consolelog(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "console.log( \"hier beim Punkt1\" );");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void mnJavaScript_Accessmulticheckbox(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let checkboxes=document.getElementsByName('chkgroup');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for (let i=0; i<checkboxes.length; i++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (checkboxes[i].checked) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "  // checkboxes[i].value");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());  
        }

        public static void mnJavaScript_AccessRadiobutton(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let select=\"\"");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for (let i=0; i<form.rb.length; i++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (form.rb[i].checked) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "select = form.rb[i].value;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // if");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // for ");
            editor.InsertZeile(sb.ToString());
        }

        public static void JavaScript_Access_comboboxMultiple(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let select = form.elements['selectFunctions[]'];");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (select.selectedOptions.length <= 0) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('Bitte mindestens eine Operation auswählen!');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} // if");
            editor.InsertZeile(sb.ToString());
        }





        public static void InsertJavaScript_ajax_getElementById(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let element = document.getElementById(\"id\");");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertJavaScript_ajax_getElementsByClassName(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let elements = document.getElementsByClassName(\"myclass\");");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertJavaScript_ajax_getElementsByName(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let elements = document.getElementsByName(\"checkboxgroupid\");");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertJavaScript_ajax_getElementsByTagName(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let elements = document.getElementsByTagName(\"li\");");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJavaScript_ajax_innerhtml(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "element.innerHTML = '<h2>Hier ist eine Überschrift</h2>';");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "element.style.display = 'block';	// Einschalten");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "element.style.display = 'none';		// Ausschalten");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJavaScript_Display_None(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + Konst.C_TAB + "elementAjax.style.display=\"none\";");
        }
        public static void InsertJavaScript_Display_Inline(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + Konst.C_TAB + "elementAjax.style.display=\"inline\";");
        }
        public static void InsertJavaScript_Display_Block(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + Konst.C_TAB + "elementAjax.style.display=\"block\";");
        }


        public static void InsertJavaScript_jsonforloop(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "let objs = JSON.parse(form.input1.value);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "for (let i in objs) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let obj = objs[i];");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for(let j in obj) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert(obj[j]);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertJavaScript_ajaxStructur(Window parent, MyTextBox editor)    {
            WReadXMLHttpRequest dialog = new WReadXMLHttpRequest(parent);
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String suffix = dialog.tSuffix.Text.Trim();
                String xmlhttp = "xmlhttp" + suffix;
                String receiveJson = "receiveJson" + suffix;
                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "<script type=\"text/javascript\">");

                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// <![CDATA[");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
                sb.AppendLine();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let "+ xmlhttp + " = new XMLHttpRequest();");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + xmlhttp + ".onreadystatechange = " + receiveJson + ";");  // Funktionspointer");
                sb.AppendLine(); 
                sb.AppendLine(); 
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "function startAjax(form) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let param = 'Bsp01.php?Wert=' + 123 + '&Name=' + 'abc';");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert(param);");

                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + xmlhttp + ".open(\"GET\", param);");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + xmlhttp + ".setRequestHeader('Pragma', 'no-cache');");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + xmlhttp + ".setRequestHeader('Cache-Control', 'must-revalidate');");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + xmlhttp + ".send();");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // startAjax");
                sb.AppendLine(); 
                sb.AppendLine();

                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "function "+ receiveJson+"() {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"use strict\";");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// alert(" + xmlhttp + ".readyState);");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if ("+xmlhttp + ".readyState == 4) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (" + xmlhttp + ".status == 200) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let elementAjax = document.getElementById(\"ajax\");");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert(" + xmlhttp + ".responseText);");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "//elementAjax.innerHTML= " + xmlhttp + ".responseText;");
                sb.AppendLine();

                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "/*");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let result = JSON.parse("+ xmlhttp+".responseText);");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (result.isError) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "elementAjax.innerHTML = '<h2>Fehler</h2>' + result.errortext;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "*/");

                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // if");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"let error = 'Fehler:\\nStatus: '+" + xmlhttp+".status +'\\nStatusText: '+" + xmlhttp+".statusText;");

                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert(error);");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // if");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  //"+receiveJson);
                sb.AppendLine();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// ]]>");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "</script>");
                editor.InsertZeile(sb.ToString());
            }  // if
        }

        // Bietz
        internal static void InsertHTML_CSSLink(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<link rel=\"stylesheet\" type=\"text/css\"  href=\"style.css\"/>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJavaScript_JQUery_link(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "<script src='https://ajax.aspnetcdn.com/ajax/jQuery/jquery-3.4.1.min.js'></script>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJavaScript_JQUery_ajax(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "$.ajax({");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "type: \"GET\", //oder POST");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "url: \"zieldatei.php\",");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "dataType: \"json\",");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "data: {zahl1: wert},");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "success: function(result){");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "//let obj = JSON.parse(result);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$(\"#ajax\").html(result);");  // $("#ajax").html(s);
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");

            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "error: function(jqXhr, textStatus, error){");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('Fehler');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "complete: function(jqXhr, textStatus){");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('Abschluss');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");


            sb.AppendLine(Konst.C_TAB + "});");
            sb.AppendLine();
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJavaScript_Event_onload(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "window.onload = function() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"  use strict\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // onload ");
            editor.InsertZeile( sb.ToString() );
        }

             
        public static void InsertJavaScript_Event_onUnload(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "window.onunload = function() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "\"  use strict\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // onunload ");
            editor.InsertZeile(sb.ToString());
        }

             

        public static void InsertJavaScript_Event_onClick(MyTextBox editor) {
            editor.InsertText("onclick=\"myClick()\"");
        }

             
        public static void InsertJavaScript_onDblclick(MyTextBox editor) {
            editor.InsertText("ondblclick=\"myDblClick();\"");
        }

             
        public static void InsertJavaScript_Event_onMouseDown(MyTextBox editor) {
            editor.InsertText("onmouseDown=\"myMouseDown()\"");
        }

            
        public static void InsertJavaScript_Event_onMouseUp(MyTextBox editor) {
            editor.InsertText("onmouseup=\"myMouseUp()\"");
        }

            
        public static void InsertJavaScript_Event_onMouseOver(MyTextBox editor)  {
            editor.InsertText("onmouseover=\"myMouseOver()\"");
        }

            
        public static void InsertJavaScript_Event_onMouseMove(MyTextBox editor) {
            editor.InsertText("onmousemove=\"myMouseMove()\"");
        }

            
        public static void InsertJavaScript_Event_onMouseOut(MyTextBox editor) {
            editor.InsertText("onmouseout=\"myMouseOut()\"");
        }

            
        public static void InsertJavaScript_Event_onFocus(MyTextBox editor) {
            editor.InsertText("onfocus=\"myOnFocus()\"");
        }

            
        public static void InsertJavaScript_Event_onBlur(MyTextBox editor) {
            editor.InsertText("onblur=\"myOnBlur()\"");
        }

            
        public static void InsertJavaScript_Event_onKeypress(MyTextBox editor)  {
            editor.InsertText("onkeypress=\"myOnKeyPress()\"");
        }

            
        public static void InsertJavaScript_Event_onKeydown(MyTextBox editor) {
            editor.InsertText("onkeydown=\"myOnKeyDown()\"");
        }

            
        public static void InsertJavaScript_Event_onKeypup(MyTextBox editor)  {
            editor.InsertText("onkeyup=\"myOnKeyUp()\"");
        }

            
            
        public static void InsertJavaScript_Event_onSelect(MyTextBox editor) {
            editor.InsertText("onselect=\"myOnSelect()\"");
        }

            
        public static void InsertJavaScript_Event_onChange(MyTextBox editor) {
            editor.InsertText("onchange=\"myOnChange()\"");
        }

            
        public static void InsertJavaScript_If(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if() {");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertJavaScript_If_Else(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertJavaScript_Dowhile(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "do {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} while();");
            editor.InsertZeile( sb.ToString() );
        }

            
        public static void InsertJavaScript_While(MyTextBox editor){
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "while() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile( sb.ToString() );
        }



        public static void InsertJavaScript_For_i(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for (i=??; i<?? ; i++ ) {");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");            
            sb.AppendLine("");            
            editor.InsertZeile( sb.ToString(),11 );
        }

        public static void InsertJavaScript_Foreach(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for (let i in objs) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertJavaScript_ForeachOf(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for (let item of objs) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertJavaScript_Switch(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "switch () {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "case 0:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "break;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "case 1:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "break;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "default:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "break;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // switch");
            sb.AppendLine("");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertJavaScript_ParseInt(MyTextBox editor){
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("     let n = parseInt(sn);");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertJavaScript_ParseFloat(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("     let n = parseFloat(sn);");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertJavaScript_isNaN(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if ( isNaN(preis) ) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} // if isNaN");
            sb.AppendLine("");
            editor.InsertZeile( sb.ToString() );
        }



        public static void InsertJavaScript_komma2Point(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("sn = sn.replace( ',' , '.' );");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertJavaScript_toFixed(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "let erg = x.toFixed(3);");            
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertJavaScript_split(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "let musik = \"Abba;Beatles;Zappa\";");            
            sb.AppendLine(Konst.C_TAB + "let values = musik.split(\";\")");            
            sb.AppendLine(Konst.C_TAB + "let erg1 = values[0];");            
            sb.AppendLine(Konst.C_TAB + "let erg2 = values[1];");         
            sb.AppendLine(Konst.C_TAB + "let erg3 = values[2];");            
            sb.AppendLine("");         
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertJavaScript_Popupwindow(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB+"let url = 'popup.xhtml';");
            sb.AppendLine(Konst.C_TAB + "// _blank,location=1,menubar=1,toolbar=1,personalbar=1,status=1,scrollbars=1,");
            sb.AppendLine(Konst.C_TAB + "let args = 'width=123,height=345,resizable';");
            sb.AppendLine(Konst.C_TAB + "let ok = window.open(url, '', args);");

        }

        public static void InsertJavaScript_WindowLocation(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "window.location = 'BspAmacon.php'");
        }
        

        public static void mnJavaScript_charAt(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".charAt(0); // return the first Character");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_charCodeAt(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".charCodeAt(0);// return the unicode of the first Character");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_concat(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".concat(\"abc\");");            
            editor.InsertZeile( sb.ToString() );
        }

        
        public static void mnJavaScript_length(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "let n = str_input.length;");
            editor.InsertZeile(sb.ToString());
        }
        public static void mnJavaScript_regex(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let regex = new RegExp('^[A-ZÄÖÜ]{1,1}[a-zäüöß]{1,29}$');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +  "if (!regex.test(form.firstname.value)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "alert('Fehlerhafter Vorname');");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void mnJavaScript_fromCharCode(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("String.fromCharCode(65); // return an 'A' 48=0,  97=a");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_indexOf(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".indexOf(\"abc\");  // return the position of abc, -1=not found, no regular expression, faster");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void mnJavaScript_lastIndexOf(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".lastIndexOf(\"\\);");  // return the last position of \, -1=not found");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_localeCompare(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".localeCompare(\"abc\"); // compare two strings, return: -1  0  +1 ");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_match(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(" // search in the string for a match: ");
            sb.AppendLine(" // \"The rain in SPAIN stays mainly in the plain\" ; result an array ain,ain,ain");
            sb.AppendLine(" // see regular expression");
            sb.AppendLine(" // http://www.w3schools.com/js/js_regexp.asp");
            sb.AppendLine(" // http://www.w3schools.com/jsref/jsref_obj_regexp.asp");
            sb.AppendLine("let ch = mystring.match(/ain/g); ");
            editor.InsertZeile(sb.ToString());
        }
        public static void mnJavaScript_replace(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("item = item.replace(\"abc\", \"xyz\");");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_replaceAll(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("item = item.replace(/abc/g, \"xyz\");");
            editor.InsertZeile(sb.ToString());
        }
        public static void mnJavaScript_search(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".search((\"abc\");  // return the position of abc, -1=not found, regular expression, slower");               
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_slice(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  // extract from the string, start, end (0->n-1)");
            sb.AppendLine("  // startindex<y0, then it start from the end");
            sb.AppendLine(".slice(1,5); ");
            editor.InsertZeile(sb.ToString());
        }
        public static void mnJavaScript_split(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("let items = mystring.split(',');  // split the string between the comma");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_substr(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".substr(1,5);  // start<= chars <= end; (0->n-1)");               
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_substring(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".substring(1,5);  // start<= chars < end; (0->n-1)");               
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_toLocaleLowerCase(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toLocaleLowerCase();");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_toLocaleUpperCase(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toLocaleUpperCase();");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_toLowerCase(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toLowerCase();");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_toString(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toString();  // one get a copy, not a reference");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_toUpperCase(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toUpperCase();");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_trim(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".trim(); // remove the spaces at the start and end");            
            editor.InsertZeile( sb.ToString() );
        }
        public static void mnJavaScript_valueOf(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".valueOf();  // The valueOf() method returns the primitive value of a String object.");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void mnJavaScript_toExponential(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toExponential();  // return the Exponential-Number.");            
            editor.InsertZeile( sb.ToString() );
        }

        public static void mnJavaScript_Insert(MyTextBox editor, String item) {
            editor.InsertText(item);
        }

        // https://wiki.selfhtml.org/wiki/JavaScript/Objekte/Array
        public static void JavaScript_Arrays_createArray(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("   let feld = [];  // new Array(MAX);  MAX elements");
            editor.InsertZeile(sb.ToString());
        }
        public static void JavaScript_Arrays_createMultidimArray(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "let feld = new Array(MAX)");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for (let i=0; i<MAX; ii++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "feld[i] = new Array(MAX)");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        
        public static void JavaScript_lengthArray(MyTextBox editor) {
            editor.InsertText(".length");
        }

        public static void JavaScript_Arrays_pushArray(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("   feld.push( new MyClass() );");
            editor.InsertZeile(sb.ToString());
        }
        public static void JavaScript_Arrays_sliceArray(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("   feld.slice( i, 1 );");
            editor.InsertZeile(sb.ToString());
        }
        public static void JavaScript_Class_createClass(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("   function MyClass (x,y) {");
            sb.AppendLine("      this.x = x;");
            sb.AppendLine("      this.y = y;");
            sb.AppendLine();
            sb.AppendLine("      this.sysoX = function () {");
            sb.AppendLine("         alert('x:'+this.x);");
            sb.AppendLine("      }");
            sb.AppendLine();
            sb.AppendLine("      this.getX = function () {");
            sb.AppendLine("         return this.x;");
            sb.AppendLine("      }");
            sb.AppendLine();
            sb.AppendLine("      this.setX = function (x) {");
            sb.AppendLine("        this.x=x;");
            sb.AppendLine("      }");
            sb.AppendLine("   } // MyClass");
            sb.AppendLine();
            sb.AppendLine("    // used: ");
            sb.AppendLine("    let instance = new MyClass ();");            
            editor.InsertZeile(sb.ToString());
        }
        public static void JavaScript_Class_StaticAttribut(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("   MyClass.color='blue';");
            editor.InsertZeile(sb.ToString());
        }
        

    
        public static void mnJavaScript_toPrecision(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(".toPrecision(4);  // return the string with 4 chars.");            
            editor.InsertZeile( sb.ToString() );
        }
              
        public static void InsertPHP_Sector(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<?php");
            sb.AppendLine(Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + "");
            sb.AppendLine("?>");           
            editor.InsertZeile( sb.ToString() ); 
        }

        public static void InsertPHP_Funktion(MyTextBox editor) {
            WInputString dialog = new WInputString();
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String name = dialog.NameOfFunction[0].ToString().ToLower() + dialog.NameOfFunction.Substring(1);
                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "function " + name + "() {");
                sb.AppendLine("");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
                sb.AppendLine("");
                editor.InsertZeile(sb.ToString());
            }
        }

        public static void InsertPHP_Numberformat(MyTextBox editor) {
            editor.InsertZeile("number_format($x, 2);");
        }
        public static void InsertPHP_Round(MyTextBox editor) {
            editor.InsertZeile("round($number, 2);");
        }
        public static void InsertPHP_Sprintf(MyTextBox editor) {
            editor.InsertZeile("sprintf('%.2f', $number);");
        }
        public static void InsertPHP_Printf(MyTextBox editor) {
            editor.InsertZeile("printf('%.2f', $number);");
        }
        // absabs
        public static void InsertPHP_Abs(MyTextBox editor) {
            editor.InsertZeile("abs($number);");
        }
        public static void InsertPHP_Ceil(MyTextBox editor) {
            editor.InsertZeile("ceil($number);  // nearest integer  0,6=>1   5,1=>6   -5.1=>-5");
        }
        public static void InsertPHP_Dechex(MyTextBox editor) {
            editor.InsertZeile("dechex('30'); // 0> 1E");
        }
        public static void InsertPHP_Decoct(MyTextBox editor) {
            editor.InsertZeile("decoct('12');  // => 10");
        }
        public static void InsertPHP_Floor(MyTextBox editor) {
            editor.InsertZeile("floor($number);  // nearest integer  0,6=>0   5,1=>5   -5.1=>-6");
        }
        public static void InsertPHP_Intdiv(MyTextBox editor) {
            editor.InsertZeile("intdiv(8, 4);  // wie in Java");
        }
        public static void InsertPHP_Max(MyTextBox editor) {
            editor.InsertZeile("max(2,5,4,33);");
        }
        public static void InsertPHP_Min(MyTextBox editor) {
            editor.InsertZeile("min(2,5,4,33);");
        }
        public static void InsertPHP_Pi(MyTextBox editor) {
            editor.InsertZeile("pi();");
        }
        public static void InsertPHP_Pow(MyTextBox editor) {
            editor.InsertZeile("pow(-2,-3.2);");
        }

        public static void InsertPHP_Matrix(MyTextBox editor) {
                StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "function createMatrix($n, $m) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$mat = array();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for ($r = 0; $r <$n; $r++) {}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$row = array();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for ($c = 0; $c <$m; $c++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$row[] = 0;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$mat[] = $row;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return $mat}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        // InsertPHP
        public static void PHP_IncludePHPFile(MyTextBox editor, String filename) {
            // die lanege Varinate muss sein!
            editor.InsertZeile(Konst.C_TAB + "include_once('" + filename+ "');");
        }

        public static void PHP_RequirePHPFile(MyTextBox editor, String filename) {
            // die lanege Varinate muss sein!
            editor.InsertZeile(Konst.C_TAB + "require_once('" + filename + "');");
        }


        public static void InsertPHP_If(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_If_Else(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertPHP_If_ElseIf(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "elseif () {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }

        

        public static void InsertPHP_Dowhile(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "do {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} while();");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_While(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "while() {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_Foreach(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "foreach ($liste as $item) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_For_i(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "for ($i=$n; $i<$n ; $i++ ) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString(), 11);
        }


        public static void InsertPHP_Switch(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "switch ($??) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "case 0:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "break;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "case 1:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "break;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "default:");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "break;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // switch");
            sb.AppendLine("");
            editor.InsertZeile(sb.ToString());
        }


        public static void PHP_ClassResult(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "class Result {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public $zahl=0;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public $errortext='';");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public $isError=false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public function  __construct($zahl) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$this->zahl = $zahl;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }
        public static void PHP_ClassNumber(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "class Number {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public $zahl=0;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public function  __construct($zahl) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$this->zahl = $zahl;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        public static void PHP_AttributeSetGet(MyTextBox editor) {
            WInputString dialog = new WInputString();
            dialog.Title = "New attrib";
            dialog.labelTitel.Content = "Name of the new attrib (without $)";
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String attrib = dialog.NameOfFunction;
                if (attrib.StartsWith("$")) {
                    attrib = attrib.Substring(1);
                }
                // Check name
                String attriblower = attrib.ToLower();
                attrib = attriblower.Substring(0, 1) + attrib.Substring(1);
                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "private $" + attrib+";");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public function get" + attrib + "() {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return $this->" + attrib + ";");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public function set" + attrib + "($value) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$this->" + attrib + "=$value;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
                editor.InsertZeile(sb.ToString());
            }
        }
        public static void PHP_JSon_encodepur(MyTextBox editor)  {
            editor.InsertZeile(Konst.C_TAB + Konst.C_TAB + "echo json_encode(...);");
        }

        public static void PHP_JSon(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();            
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "private function processArray($array)  {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "foreach ($array as $key => $value) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (is_object($value)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$array[$key] = $value->toArray();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}  // if");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (is_array($value)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$array[$key] = $this->processArray($value);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "} // foreach");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// If the property isn't an object or array, leave it untouched");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return $array;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "public function toArray()  {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "return $this->processArray(get_object_vars($this));");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }
        public static void PHP_json_encode(MyTextBox editor)
        {
            editor.InsertZeile("  $ergebnis = json_encode($std->toArray());");
        }


        public static void PHP_InsertPHP_isset(MyTextBox editor) {
            WInputString dialog = new WInputString();
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String bez = dialog.NameOfFunction;

                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + "if ( isset($_GET['" + bez + "']) ){		 //	Ist gesetzt?");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$str_"+ bez + " = $_GET['"+ bez+"'];");
                sb.AppendLine(Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + "else {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: The param '" + bez + "' are not passed\";");
                sb.AppendLine(Konst.C_TAB + "}");

                editor.InsertZeile(sb.ToString());
            }
        }


        public static void PHP_InsertcheckIssetInt(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// global $ok $errortext");
            sb.AppendLine(Konst.C_TAB + "function checkIssetInt($bez) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "global $ok;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "global $errortext;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$zahl = 0;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "if (isset($_GET[$bez])) {   // Ist gesetzt?");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"$str_zahl = $_GET[$bez];");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"if (is_numeric($str_zahl)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB+ Konst.C_TAB +"$zahl = intval( $str_zahl, 10);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +Konst.C_TAB +"$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$errortext.= \"Error in number conversion: the variable '$bez' is not any number\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB +"$errortext.= \"Error: The param '$bez' are not passed\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "return $zahl;");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }  



        public static void PHP_InsertcheckIssetFloat(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// global $ok $errortext");
            sb.AppendLine(Konst.C_TAB + "function checkIssetFloat($bez) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "global $ok;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "global $errortext;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$zahl = 0.0;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "if (isset($_GET[$bez])) {   // Ist gesetzt?");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$str_zahl = $_GET[$bez];");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (is_numeric($str_zahl)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$zahl = floatval( $str_zahl);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$errortext.= \"Error in number conversion: the variable '$bez' is not any number\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$errortext.= \"Error: The param '$bez' are not passed\";");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "return $zahl;");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertPHP_IsnumericInt(MyTextBox editor) {
            WInputString dialog = new WInputString();
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String bez = dialog.NameOfFunction;
                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + "if (is_numeric($str_"+bez+")) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$"+ bez+" = intval ( $str_"+ bez+", 10 );");
                sb.AppendLine(Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + "else {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error in number conversion: the variable '"+ bez + "' is not any number\";");
                sb.AppendLine(Konst.C_TAB + "}");
                editor.InsertZeile(sb.ToString());
            }
        }

        public static void InsertPHP_IsnumericFloat(MyTextBox editor) {
            WInputString dialog = new WInputString();
            dialog.ShowDialog();
            if (dialog.Retcode) {
                String bez = dialog.NameOfFunction;
                StringBuilder sb = new StringBuilder();
                sb.AppendLine(Konst.C_TAB + "if (is_numeric($str_" + bez + ")) {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$" + bez + " = floatval ( $str_" + bez + ");");
                sb.AppendLine(Konst.C_TAB + "}");
                sb.AppendLine(Konst.C_TAB + "else {");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
                sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error in number conversion: the variable '" + bez + "' is not any number\";");
                sb.AppendLine(Konst.C_TAB + "}");
                editor.InsertZeile(sb.ToString());
            }
        }


        public static void InsertPHP_IsInt(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "if (is_int( $var)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// action;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: no int variable\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_IsFloat(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "if (is_float( $var)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// action;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: no float variable\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }



        public static void InsertPHP_IsBool(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "if (is_bool( $var)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// action;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: no bool variable\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_IsString(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "if (is_string( $var)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// action;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: no string variable\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_IsObject(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "if (is_object( $var)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// action;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: no object variable\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertPHP_IsArray(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "if (is_array( $var)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// action;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok = false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: no array variable\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }





        public static void PHP_InsertPHP_issetSelectMultiple(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "// the name of the select ui-element must have a '[]'");
            sb.AppendLine(Konst.C_TAB + "$liste = array();");
            sb.AppendLine(Konst.C_TAB + "if ( isset($_GET['liste']) ){   // Is the list gesetzt?");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "foreach ($_GET['prfs'] as $item) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "$liste[] = $item;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$ok =false;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "$errortext.=\"Error: Der Parameter 'liste' wurde nicht übergeben\";");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }



              
        public static void InsertPHP_IntVal(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("Konst.C_TAB + $zahl = intval ( $str_zahl );");
            editor.InsertZeile( sb.ToString() );
        }

        // -------------------------------------
        public static void InsertPHP_createArray(MyTextBox editor)   {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "$feld = array();");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertPHP_createArrayWithItems(MyTextBox editor)   {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  $feld = array(\"red\", \"blue\", \"green\");");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertPHP_createMultidimArray(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "$colors = array");
            sb.AppendLine(Konst.C_TAB + "(");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "array('green',0,0,255),");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "array('red',255,0,0),");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "array('lightgray',200,200,200),");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "array('orange',255,128,0)");
            sb.AppendLine(Konst.C_TAB + ");");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertPHP_pushArray(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("  $feld[] = \"newItem\";");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertPHP_Arrays_arrayLength(MyTextBox editor)   {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "$numberOfElements = count($feld)");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertPHP_Arrays_foreach(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "foreach ($feld as $item) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "echo $item . '<br />';");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        

        public static void InsertPHP_Regex(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            //sb.AppendLine(Konst.C_TAB + "$match = '/^[A-ZÄÖÜ]{1,1}[a-zäüöß]{1,29}$/';");
            sb.AppendLine(Konst.C_TAB + "$match = '/^[A-ZÄÖÜ]{1,1}[a-zäüöß]{1,29}$/';");
            sb.AppendLine(Konst.C_TAB + "if(!preg_match($match, $lastname)) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "echo 'Fehlerhafter Nachname';");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }

        // neu
    public static void InsertPHP_char(MyTextBox editor) {
            editor.InsertText("chr(65);   // ergibt ein A");
        }


    public static void InsertPHP_Explode(MyTextBox editor) {
        StringBuilder sb = new StringBuilder();
        sb.AppendLine("$staedte = 'Stuttgart->Esslingen->Filderstadt';");
        sb.AppendLine("$orte = explode(\"->\", $staedte );");
        sb.AppendLine("echo $orte[0];   // Ausgabe Stuttgart");
        editor.InsertZeile(sb.ToString());
    }

    public static void InsertPHP_Ltrim(MyTextBox editor) {
            editor.InsertText("ltrim($str);   // löschen vorne");
        }

    public static void InsertPHP_Rtrim(MyTextBox editor) {
            editor.InsertText("rtrim($str);   // löschen hinten");
        }

        public static void InsertPHP_Trim(MyTextBox editor) {
            editor.InsertText("trim($str);   // löschen vorne und hinten");
        }

     public static void InsertPHP_Strlen(MyTextBox editor) {
            editor.InsertText("strlen($str);   // String-length");
        }

        public static void InsertPHP_Replace(MyTextBox editor) {
            editor.InsertText("$s = str_replace('a','b',$s);   // ersetze in $s  'a' durch 'b'");
        }


        public static void InsertPHP_Bin2Hex(MyTextBox editor) {
            editor.InsertText(Konst.C_TAB + "echo bin2hex('001100011');   // also hex2bin");
        }

        public static void InsertPHP_Str_split(MyTextBox editor) {
            editor.InsertText(Konst.C_TAB + "echo str_split('abcdef');   // str_split($str, 3);  every 3 chars");
        }

        public static void InsertPHP_Strtok(MyTextBox editor) {
            editor.InsertText("$tok = strtok($string, 'abc'  // trennen nach jedem 'abc'.");
        }
        public static void InsertPHP_ord(MyTextBox editor) {
            editor.InsertText("$chValue = ord('A');   // ergibt 65");
        }

        public static void InsertPHP_Substr(MyTextBox editor) {
            editor.InsertText("substr ( $str , $start [, int $length ] ); // start<0:vom Ende");
        }

        public static void InsertPHP_Strtolower(MyTextBox editor) {
            editor.InsertText("strtolower($str)");
        }

        public static void InsertPHP_Strtoupper(MyTextBox editor) {
            editor.InsertText("strtoupper($str)");
        }


        public static void PHP_Startwith(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "function startsWith($item, $search) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "return (substr($item, 0, strlen($search)) === $search);");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertText(sb.ToString());
        }




        // -------------------------------------


        public static void InsertPHP_echoText(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "echo '<p>Hier kommt ein Text in der HTML-Datei</p>' . PHP_EOL;");
            editor.InsertZeile( sb.ToString() );
        }

              
        public static void InsertPHP_echoStringAndVariable(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "$Number=42;");
            sb.AppendLine(Konst.C_TAB + "echo \"<p>Number: $Number</p>\r\n\",PHP_EOL;");
            editor.InsertZeile( sb.ToString() );
        }

              
        public static void InsertPHP_echoStringAndVariable_withPoint(MyTextBox editor){
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "$zahl=42;");
            sb.AppendLine(Konst.C_TAB + "echo \"<p>Zahl: \" . $zahl . \"</p>\",PHP_EOL;");
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertPHP_weiterleitung(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "header('location:nextHtml.xhtlm');");
            sb.AppendLine(Konst.C_TAB + "exit(1);");
            editor.InsertZeile(sb.ToString());
        }
        

        // JSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSPJSP

        public static void InsertJSP_Directive(MyTextBox editor, String import)   {
            editor.InsertZeile("<%@ page "+ import+" %>");            
        }
        public static void InsertJSP_Deklaration(MyTextBox editor)
        {
            editor.InsertZeile("<%! int n=0; %>");
        }
        public static void InsertJSP_Scriptlet(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<%");
            sb.AppendLine(Konst.C_TAB + "int i=0;");
            sb.AppendLine(Konst.C_TAB + "out.println(\"Dieses Wizzard kostet 5,80 Dong\");");
            sb.AppendLine("%>");
            editor.InsertZeile(sb.ToString());
        }
        public static void InsertJSP_Expression(MyTextBox editor)  {
            editor.InsertText("<%= value %>");
        }
        public static void InsertJSP_Comment(MyTextBox editor)  {
            editor.InsertZeile(Konst.C_TAB + "<%-- jsp comment --%>");
        }

        public static void JavaJSP_IncludeJSP(MyTextBox editor, String filename) {
            editor.InsertZeile(Konst.C_TAB + "<%@ include file=\"" + filename + "\" %>");
        }



        public static void mnJSP_getBytes(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "byte[] zeichen = s.getBytes();");
        }

        internal static void mnJSP_charAt(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "char ch = s.charAt(i);");
        }

        internal static void mnJSP_toCharArray(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "char[] zeichen = s.toCharArray()");
        }

        internal static void mnJSP_indexOf(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "int index = s.indexOf('a')");
        }

        internal static void mnJSP_indexOfStr(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "int index = s.indexOfStr(\"ab\")");
        }

        internal static void mnJSP_ltrim(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "s.ltrim();");
        }

        internal static void mnJSP_rtrim(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "s.rtrim();");
        }

        internal static void mnJSP_trim(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "s.trim();");
        }

        internal static void mnJSP_split(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "String[] parts=string.split(\abc\");");
        }

        internal static void mnJSP_substring(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "s1 = s.substring(0,4);");
        }

        internal static void mnJSP_toLowerCase(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "s1=s.toLowerCase();");
        }

        internal static void mnJSP_Startswith(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "boolean b=s.startsWith(\"abc\");");
        }

        internal static void mnJSP_toUpperCase(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "s1=s.toUpperCase();");
        }

        internal static void mnJSP_strlen(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "int len = s.length();");
        }

        internal static void mnJSP_lastIndexOf(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "int index = s.lastIndexOf('\t')");
        }

        internal static void mnJSP_ord(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "xxxx");
        }

        internal static void mnJSP_codePointAt(MyTextBox editor) {
            editor.InsertZeile(Konst.C_TAB + "int ch = s.codePointAt(0);  // unicode");
        } 



        public static void mnJSP_Calender(MyTextBox editor)    {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine(Konst.C_TAB + "Calendar c = df.getCalendar();  // Dieser Kalender hat noch kein Datum !");
            sb.AppendLine(Konst.C_TAB + "c.setTimeInMillis(System.currentTimeMillis());");
            sb.AppendLine(Konst.C_TAB + "int day = c.get(Calendar.DAY_OF_MONTH);  // MONTH, YEAR, DAY");
            editor.InsertZeile(sb.ToString());
        }
        public static void mnJSP_SimpleDateFormat(MyTextBox editor) {
            StringBuilder sb = new StringBuilder();

            sb.AppendLine(Konst.C_TAB + "SimpleDateFormat df = new SimpleDateFormat(\"HH: mm:ss\");");
            sb.AppendLine(Konst.C_TAB + "String uhrzeit = df.format(new Date());");
            sb.AppendLine(Konst.C_TAB + "out.println(uhrzeit);");

            editor.InsertZeile(sb.ToString());
        }

        public static void InserJSP_getParam(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "String str_zahl = request.getParameter(\"key\");");
            editor.InsertZeile(sb.ToString());
        }

        public static void InserJSP_getParams(MyTextBox editor)  {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "String[] dummies = request.getParameterValues(\"themen\");");
            sb.AppendLine(Konst.C_TAB + "if (dummies==null) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "ok=false;"); 
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "for( String item : dummies) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "// action");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "}");
            editor.InsertZeile(sb.ToString());
        }


        public static void mnJSP_Json(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<%@ page import = \"java.util.* \" %>");
            sb.AppendLine("<%@ page import = \"java.lang.reflect.* \" %>");
            sb.AppendLine();
            sb.AppendLine("<%!");
            sb.AppendLine();
            sb.AppendLine("private String getJSonArray(Object[] objs) {");
            sb.AppendLine(Konst.C_TAB + "StringBuilder sb = new StringBuilder();");
            sb.AppendLine(Konst.C_TAB + "if (objs.length==0) {");
            sb.AppendLine(Konst.C_TAB + "return \"[]\";");
            sb.AppendLine("}");
            sb.AppendLine(Konst.C_TAB + "sb.append(\"[ \" );");
            sb.AppendLine(Konst.C_TAB + "int n = objs.length;       ");
            sb.AppendLine(Konst.C_TAB + "for(int i=0; i<n; i++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "sb.append(getJSon(objs[i]));");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "if (i<n-1) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "sb.append(\", \");");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}  // if");
            sb.AppendLine(Konst.C_TAB + "}  // for");
            sb.AppendLine(Konst.C_TAB + "sb.append(\" ]\");");
            sb.AppendLine(Konst.C_TAB + "return sb.toString();");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("private String getJSonArraylist(ArrayList objs) {");
            sb.AppendLine(Konst.C_TAB + "StringBuilder sb = new StringBuilder();");
            sb.AppendLine(Konst.C_TAB + "if (objs.size()==0) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "return \"[]\";");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "sb.append(\"[ \" );");
            sb.AppendLine(Konst.C_TAB + "int n = objs.size();       ");
            sb.AppendLine(Konst.C_TAB + "for(int i=0; i<n; i++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "sb.append(getJSon(objs.get(i)));");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "if (i<n-1) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "sb.append(\", \");");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "} // for");
            sb.AppendLine(Konst.C_TAB + "sb.append(\" ]\");");
            sb.AppendLine(Konst.C_TAB + "return sb.toString();");
            sb.AppendLine("}");
            sb.AppendLine();
            sb.AppendLine();
            sb.AppendLine("private String getJSon(Object obj) {");
            sb.AppendLine(Konst.C_TAB + "StringBuilder sb = new StringBuilder();");
            sb.AppendLine(Konst.C_TAB + "try {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Class c = obj.getClass();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "Field[] fields; ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "fields = c.getDeclaredFields();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "// {  {\"name\": \"Meier59\", \"mnr\":12345} ");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "sb.append(\"{\");");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "int n=fields.length-1;");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "for(int i=0; i<n; i++) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "Field field = fields[i];");
            String s = "sb.append(\"x\");";
            s = s.Replace("x", "\\\"");             // sb.append("\"");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + s);

            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "sb.append(field.getName());");
            String s2 = "sb.append(\"x:\");";
            s2=s2.Replace("x","\\\"");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + s2);
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "String s=field.getType().toString();");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (s.indexOf(\"String\")>0) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + s);
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "sb.append(field.get(obj));");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + s);
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "else {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "sb.append(field.get(obj));");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "if (i<n-1) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "sb.append(\", \");");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "sb.append(\"}\");");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "catch ( IllegalAccessException e) {");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "return sb.toString();");
            sb.AppendLine("}");
            sb.AppendLine(" ");
            sb.AppendLine("%>");
            sb.AppendLine();
            editor.InsertZeile(sb.ToString());
        }


        public static void InsertJSP_parseInt(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<%!");
            sb.AppendLine("Integer getIntNumber(String str_zahl) {");
            sb.AppendLine(Konst.C_TAB + "try {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "int zahl = Integer.parseInt(str_zahl);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "return new Integer(zahl);");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "catch (NumberFormatException e) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "return null;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine("}  // getIntNumber");
            sb.AppendLine("%>");
            sb.AppendLine();
  

            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJSP_parseDouble(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine("<%!");
            sb.AppendLine("double getDoubleNumber(String str_zahl) {");
            sb.AppendLine(Konst.C_TAB + "try {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "double zahl = Double.parseDouble(str_zahl);");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "return zahl;");
            sb.AppendLine(Konst.C_TAB + "}");
            sb.AppendLine(Konst.C_TAB + "catch (NumberFormatException e) {");
            sb.AppendLine(Konst.C_TAB + Konst.C_TAB + "return Double.NaN;");
            sb.AppendLine(Konst.C_TAB + "}  // try");
            sb.AppendLine("}  // getDoubleNumber       Abfrage:   if (Double.isNaN(Zahl)) {..}");
            sb.AppendLine("%>");
            editor.InsertZeile(sb.ToString());
        }

        public static void InsertJSP_echoText(MyTextBox editor)
        {
            editor.InsertZeile(Konst.C_TAB + "out.println();",13);
        }

        public static void InserJSP_echoStringAndVariable(MyTextBox editor)
        {
            StringBuilder sb = new StringBuilder();
            sb.AppendLine(Konst.C_TAB + "int value=12;");
            sb.AppendLine(Konst.C_TAB + "out.println(\"<h2>Here is a variable: \"+ value+\"</h2>\");");
            editor.InsertZeile(sb.ToString(),22);
        }


        // -------------------------------------




        public static void InsertHTML_InsertImage(MyTextBox editor, string sImagefile, bool bWithCoord) {
            StringBuilder sb = new StringBuilder();
            if (bWithCoord) 
            {
                sb.AppendLine(Konst.C_TAB + "<img src=\"" + Basis.getFilename(sImagefile) + "\" title=\"Text of description\"  usemap=\"#shapeareaname\" />");
                sb.AppendLine(Konst.C_TAB + "<map name=\"shapeareaname\">");
                sb.AppendLine();
                sb.AppendLine(Konst.C_TAB + "</map>");
            }
            else {
                sb.AppendLine(Konst.C_TAB + "<img src=\"" + Basis.getFilename(sImagefile) + "\" title=\"Text of description\"  />");
            }
            editor.InsertZeile( sb.ToString() );
        }


        public static void InsertImageCoords(MyTextBox editor) {
            WCoords dialog = new WCoords();
             dialog.ShowDialog();
             string sCoords;
             if (dialog.Retcode) {
                 sCoords = dialog.getCoords();
                 StringBuilder sb = new StringBuilder();
                 // sb.AppendLine("  <br />");
                 sb.AppendLine("  " + sCoords);
                 // sb.AppendLine("  <br />");
                 editor.InsertZeile(sb.ToString());
             }
         }

        public static void InsertImageCoordsFromSHWFile(MyTextBox editor) {
            int i, j, Image_w, Image_h;
            int m, n;
            double minX = 0.0, maxX = 0.0;
            double minY = 0.0, maxY = 0.0;
            double Faktor, x, y, yPixel1, yPixel2;
            int ix, iy;
            int diff_x, diff_y;
            string sName;
            string sKoord;
            int anz;
            //// PictureBox pictureBox1;
            string sLine;

            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.DefaultExt = ".png";
            openFileDialog.InitialDirectory = SingVar.LastPath;
            openFileDialog.Filter = "PNG-Files (*.png)|*.png|" +
                                      "JPG-Files (*.jpg;*.jpeg)|*.jpg;*.jpeg|" +
                                     "BMP-Files (*.bmp)|*.bmp|" +
                                      "GIF-Files (*.gif)|*.gif|" +
                                      "All Pictures (*.png;*.jpg;*.jpeg;*.bmp;*.gif)|*.png;*.jpg;*.jpeg;*.bmp;*.gif|" +
                                      "All files (*.*)|*.*";

            openFileDialog.Multiselect = false;
            openFileDialog.Title = "Open image file";

            if (openFileDialog.ShowDialog(null) == true) {
                BitmapImage btImage = new BitmapImage();
                btImage.BeginInit();
                btImage.UriSource = new Uri(openFileDialog.FileName, UriKind.Absolute);
                btImage.EndInit();
                //pictureBox1 = new System.Windows.Forms.PictureBox();
                //pictureBox1.Image = System.Drawing.Image.FromFile(openFileDialog.FileName);
                //pictureBox1.SizeMode = PictureBoxSizeMode.Normal;
                Image_w = (int)btImage.Width;
                Image_h = (int)btImage.Height;

                openFileDialog.Filter = "SHW-Files (*.shw)|*.shw|" + "All files (*.*)|*.*";
                openFileDialog.Title = "Open coords file from ArcView";
                openFileDialog.DefaultExt = ".shw";
                openFileDialog.FileName = "*.shw";
                if (openFileDialog.ShowDialog(null) == true) {
                    string sFilename = openFileDialog.FileName;
                    FileStream inFile = new FileStream(sFilename, FileMode.Open);
                    StreamReader inStream = new StreamReader(inFile);
                    sLine = inStream.ReadLine();  // readln(kanal,n);  // Typ
                    n = Convert.ToInt32(sLine);
                    if ((n != 2) && (n != 3)) {
                        Basis.ErrorMsg("Die SHW-Datei hat ein falsches Format (Punktshape)", "Hinweis");
                        inStream.Close();
                        inFile.Close();
                        return;
                    }

                    // Bestimme min und max
                    sLine = inStream.ReadLine();  // Anzahl der Linien
                    n = Convert.ToInt32(sLine);
                    for (i = 0; i < n; i++) {
                        sLine = inStream.ReadLine();  // Name
                        sLine = inStream.ReadLine();  // Anzahl der Koord
                        m = Convert.ToInt32(sLine);
                        for (j = 0; j < m; j++) {
                            sLine = inStream.ReadLine();  // Anzahl der Koord
                            x = Convert.ToDouble(sLine, System.Globalization.CultureInfo.InvariantCulture);
                            sLine = inStream.ReadLine();  // Anzahl der Koord
                            y = Convert.ToDouble(sLine, System.Globalization.CultureInfo.InvariantCulture);
                            if ((i == 1) && (j == 1)) {
                                minX = x;
                                maxX = x;
                                minY = y;
                                maxY = y;
                            }
                            else {
                                if (x < minX) minX = x;
                                if (x > maxX) maxX = x;
                                if (y < minY) minY = y;
                                if (y > maxY) maxY = y;
                            }
                        } // for j
                    } // for i
                    inStream.Close();
                    inFile.Close();
                    diff_x = (int)Math.Round(maxX - minX);
                    diff_y = (int)Math.Round(maxY - minY);
                    x = diff_x / Image_w;
                    y = diff_y / Image_h;
                    if (x > y)
                        Faktor = x;
                    else
                        Faktor = y;


                    inFile = new FileStream(sFilename, FileMode.Open);
                    inStream = new StreamReader(inFile);
                    sLine = inStream.ReadLine();  // readln(kanal,n);  // Typ
                    n = Convert.ToInt32(sLine);
                    if ((n != 2) && (n != 3)) {
                        Basis.ErrorMsg("Die SHW-Datei hat ein falsches Format (Punktshape)", "Hinweis");
                        inStream.Close();
                        inFile.Close();
                        return;
                    }

                    StringBuilder sb = new StringBuilder();
                    sLine = inStream.ReadLine();  // Anzahl der Linien
                    n = Convert.ToInt32(sLine);
                    for (i = 0; i < n; i++) {
                        sName = inStream.ReadLine();  // Name                        
                        sLine = inStream.ReadLine();  // Anzahl der Koord
                        m = Convert.ToInt32(sLine);
                        sb.AppendLine("    <area shape=\"poly\" alt=\"" + sName + "\" coords=");
                        sKoord = "       \"";
                        anz = 0;
                        for (j = 0; j < m; j++) {
                            sLine = inStream.ReadLine();  // Anzahl der Koord
                            x = Convert.ToDouble(sLine, System.Globalization.CultureInfo.InvariantCulture);
                            sLine = inStream.ReadLine();  // Anzahl der Koord
                            y = Convert.ToDouble(sLine, System.Globalization.CultureInfo.InvariantCulture);
                            ix = (int)Math.Round((x - minX) / Faktor);
                            // Y-Achse ist in ArcView vertauscht, Ymax ist oben
                            // Formel:  y(pixel) =   (1.0 - ((Yi-Ymin)/(Ymax-Ymin))*ImageHeight
                            yPixel1 = (y - minY) / (maxY - minY);  // pronzetualer Anteil in der Originalhoehe
                            yPixel2 = (1.0 - yPixel1);
                            iy = (int)Math.Round(yPixel2 * Image_h);
                            if (j + 1 < m)
                                sKoord += ix.ToString() + "," + iy.ToString() + " ,";
                            else
                                sKoord += ix.ToString() + "," + iy.ToString();
                            anz++;
                            if (anz == 10) {
                                sb.AppendLine(sKoord);
                                sKoord = "       ";
                                anz = 0;
                            }

                        } // for j
                        sKoord += "\" href=\"gem_" + (i + 1).ToString() + ".xhtml\" />";
                        sb.AppendLine(sKoord);
                    } // for i
                    inStream.Close();
                    inFile.Close();
                    editor.InsertZeile(sb.ToString());
                }  // if openDialog
            }
        }  // InsertImageCoordsFromSHWFile



    }
}
